(*$I Tools    *)   (* As long as GPC does not compile Units   *)
(*$I Objects  *)   (* automatically, :-( I include them here. *)
(*$I Events   *)
(*$I Displays *)


Program Hallo;  (* German word for "Hello" :-) *)


(*$I CompOpts.icl *)  (* Reasonable compiler options.     *)
                      (* Each module should include this. *)


uses
  Events,    (* Keyboard handling *)
  Displays;  (* Screen handling   *)


(* WriteChars fills a rectangular region on the screen *)
(* with a given character and a given attribute.  The  *)
(* other procedures are self-explanatory.  However,    *)
(* there is further documentation in the source file   *)
(* "displays.pas".                                     *)
(*                                                     *)
(* After "repeat ... until KeyPressed", the character  *)
(* remains in the system's keyboard buffer.  If you do *)
(* not want this, replace the loop by a single call to *)
(* "ReadKey;" as in "menus.pas".                       *)
(*                                                     *)
(* Coordinates: upper left corner is (0,0).            *)
(*                                                     *)
(* When the program is intended to run in graphics     *)
(* mode too (when it will be available), you should    *)
(* multiply all coordinates below by CharWidth resp.   *)
(* CharHeight.  In text mode, both are set to 1, so it *)
(* would make no difference.                           *)


begin
  ClearScreen ( black );
  WriteChars ( 9, 4, 8, 3, ' ', yellow + blue * background );
  WriteString ( 10, 5, 'Hallo?', yellow + blue * background );
  HideCursor;
  repeat
    (* just wait *)
  until KeyPressed;
  SetCursor ( 0, 13 );
end.
