PROGRAM Lord(Output,Input,RingFile,SaveFile);
 
 
  (* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
  (*                                                                         *)
  (*             Helsinki University Of Technology 1982-05-07                *)
  (*             ============================================                *)
  (*                                                                         *)
  (*           LLL                                                           *)
  (*           LLL                                                           *)
  (*           LLL                                                           *)
  (*           LLL                                                           *)
  (*           LLL                                                           *)
  (*           LLL                                                uFo        *)
  (*           LLL                 OOOOOO    RRRRRRRR    DDDDDDDD            *)
  (*           LLL                 OOOOOO    RRRRRRRR    DDDDDDDD            *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLL               OO      OO  RRRRRRRR    DD      DD          *)
  (*           LLL               OO      OO  RRRRRRRR    DD      DD          *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLL               OO      OO  RR      RR  DD      DD          *)
  (*           LLLLLLLLLLLLLLL   OO      OO  RR      RR  DD      DD          *)
  (*           LLLLLLLLLLLLLLL     OOOOOO    RR      RR  DDDDDDDD            *)
  (*           LLLLLLLLLLLLLLL     OOOOOO    RR      RR  DDDDDDDD            *)
  (*                                                                         *)
  (*  This program is copyright under the Nuutila Convention. All            *)
  (*  rights are reserved. Apart from any fair dealing for the               *)
  (*  purpose of private study, research, critisism or review, as            *)
  (*  permitted under the Copyright Act, no part of this program             *)
  (*  may be reprogrammed, stored in a retrieval system, or                  *)
  (*  transmitted, in any form or by any means, electronic,                  *)
  (*  electrical, chemical, mechanical, optical, photocopying,               *)
  (*  recording or otherwise, without the prior permission of the            *)
  (*  copyright owner. Enquiries should be sent to the programmer            *)
  (*  at the undermentioned address:                                         *)
  (*                                                                         *)
  (*      Helsinki University of Technology                                  *)
  (*      Computer Center                                                    *)
  (*      Olli J. Paavola                                                    *)
  (*      Otaniemi                                                           *)
  (*      FINLAND                                                            *)
  (*                                                                         *)
  (* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
  (*                                                                         *)
  (*  LORD is a game of adventure, fear, danger, joy and disappointment.     *)
  (*  In it you'll explore MWoU (= magic world of uFo).                      *)
  (*                                                                         *)
  (*  LORD was created in the Helsinki University of Technology.             *)
  (*  It was inspired by the ADVENTURE game of Crowther and Woods,           *)
  (*  D&D (Dungeon and Dragons -gamesystem) by Gygax and Arneson,            *)
  (*  the DUNGEON/ZORK , and The Ring Trilogy, The Silmarillion,             *)
  (*  The Adventures of Tom Bombadil, The Tree and the Leaf,                 *)
  (*  The Hobbit and The Unfinished Stories by JRR Tolkien.                  *)
  (*                                                                         *)
  (* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
  (*   Language: PASCAL Conforming to ISO 2nd standard Proposal              *)
  (*   Compiler: HUTCC  PAX    compiler                                      *)
  (*   Runtimes: HUTCC PAXOTS (Pax Object Time system for DEC-2060)          *)
  (*   System  : Digital Equipment Corporation DECsystem - 2060              *)
  (*                    Operating System TOPS-20                             *)
  (* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
 
 
 
 
 
 
  CONST
        PersonDimension=15;     (* * * * * * * * * * * * * * * * * * * * *)
        Now=1;                  (*                                       *)
        Before=2;               (*                                       *)
        Morale=3;               (*                                       *)
        Endurance=4;            (*                                       *)
        NegEndurance=5;         (*                                       *)
        RingRating=6;           (*       Persoonan omituisuudet          *)
        Capture=7;              (*                                       *)
        Escape=8;               (*                                       *)
        Sorcery=9;              (*                                       *)
        Load=10;                (*                                       *)
        MaxLoad=11;             (*                                       *)
        Leader=12;              (*                                       *)
        Weapon=13;              (*                                       *)
        RingOn=14;              (*                                       *)
        ArmyStrength=15;        (* * * * * * * * * * * * * * * * * * * * *)
        FirstChrNumber=-14;     (*                                       *)
        Thorin=-14;             (*                                       *)
        Nuutila=-13;            (*                                       *)
        Dwalin=-12;             (*                                       *)
        Balin=-11;              (*                                       *)
        Kili=-10;               (*                                       *)
        Fili=-9;                (*                                       *)
        Dori=-8;                (*                                       *)
        Nori=-7;                (*                                       *)
        Ori=-6;                 (*                                       *)
        Oin=-5;                 (*                                       *)
        Gloin=-4;               (*                                       *)
        Bifur=-3;               (*                                       *)
        Bofur=-2;               (*                                       *)
        Bombur=-1;              (*                                       *)
        Aragorn=0;              (*                                       *)
        Bilbo=1;                (*                                       *)
        Boromir=2;              (*                                       *)
        Frodo=3;                (*                                       *)
        Samwise=4;              (*                                       *)
        Meriadoc=5;             (*                                       *)
        Peregrin=6;             (*                                       *)
        GandalfGrey=7;          (*                                       *)
        GandalfWhite=8;         (*                                       *)
        Gimli=9;                (*                                       *)
        Legolas=10;             (*                                       *)
        Elrond=11;              (*                                       *)
        Galadriel=12;           (*                                       *)
        Celeborn=13;            (*                                       *)
        Thranduil=14;           (*                                       *)
        DainII=15;              (*                                       *)
        BrandIII=16;            (*                                       *)
        Denethor=17;            (*                                       *)
        Faramir=18;             (*                                       *)
        Imrahil=19;             (*                                       *)
        Theoden=20;             (*              Characters               *)
        Theodred=21;            (*                                       *)
        Eomer=22;               (*                                       *)
        Eowyn=23;               (*                                       *)
        Balrog=24;              (*                                       *)
        BarrowWigth=25;         (*                                       *)
        GiantTroll=26;          (*                                       *)
        Shelob=27;              (*                                       *)
        LordOfTheNazgul=28;     (*                                       *)
        Gothmog=29;             (*                                       *)
        MouthOfSauron=30;       (*                                       *)
        Nazgul3=31;             (*                                       *)
        Nazgul4=32;             (*                                       *)
        Nazgul5=33;             (*                                       *)
        Nazgul6=34;             (*                                       *)
        Nazgul7=35;             (*                                       *)
        Nazgul8=36;             (*                                       *)
        Nazgul9=37;             (*                                       *)
        ChiefOfDunlen=38;       (*                                       *)
        Saruman=39;             (*                                       *)
        Gollum=40;              (* * * * * * * * * * * * * * * * * * * * *)
        NameKuvaus=500;         (* nimien alkupaikka messuissa           *)
        KamaYxKuvaus=4000;      (* mista alkavat tavaroiden YxSanaKuvaus *)
        TupakkaTappaa=12;       (* milloin tupakka tappaa pelaajan       *)
        MistyKill=8;            (* monennellako kerralla mistyGoblinit.. *)
        EagleNotRescue=6;       (* montako kertaa kotka pelastaa rotkosta*)
        MaxHeratys=2;           (* uudelleen aloitusten enimm{ism{{r{    *)
        AlkuPaikka=301;         (* pelin aloituspaikka                   *)
        RunoTunniste=50;        (* alkurunon tunniste messuissa          *)
        MrX=800;                (* henkilotunnuksen alku                 *)
        HenkiloMaara=40;        (* henkiloiden lukumaara                 *)
        EofMs=9999;             (* luku on messufileen viimeinen tunniste*)
        MessuVarausMaara=3500;  (* paljonko varataan messuille tilaa     *)
        TavaraMaara=200;        (* montaako tavaraa pelissa kasitellaan  *)
        MontakoHuonetta=550;    (* huoneiden lukumaara                   *)
        PitkaKuvaus=2000;       (* pitkien kuvausten alkutunniste        *)
        LyhytKuvaus=3000;       (* lyhyiden kuvausten alkutunniste       *)
        PetoKuvaus =5200;       (* petokuvausten alkutunniste            *)
        KamaKuvaus =5000;       (* kamakuvausten alkutunniste            *)
        MontakoSuuntaa=12;      (* montako liikkumissuuntaa              *)
        MaxPiste=5000;          (* pelaajan mahdollinen maximipistemaara *)
        CheaterRaja=5001;       (* * * * * * * * * * * * * * * * * * * * *)
        GreatWizardRaja=5000;   (*                                       *)
        MasterWizardRaja=4500;  (*                                       *)
        JuniorWizardRaja=3700;  (*                                       *)
        MasterRaja=2500;        (*                                       *)
        WinnerRaja=2200;        (*                                       *)
        HackerRaja=1800;        (*                                       *)
        AdventurerRaja=1320;    (*       Pelaajaluokitusten rajat        *)
        JuniorAdveRaja=1050;    (*                                       *)
        AmateurAdvRaja=850;     (*                                       *)
        NoviceRaja=500;         (*                                       *)
        BeginnerRaja=190;       (*                                       *)
        LoserRaja=90;           (*                                       *)
        LousyLoser=50;          (*                                       *)
        FlatHeadRaja=20;        (* * * * * * * * * * * * * * * * * * * * *)
        TulostusLeveys=80;      (* montako merkkia messuja tulostaa      *)
        SananPituusBE=20;       (* visible-tunnisteen Maxint.pituus      *)
        VBTodennakoisyys=5;     (* petojen hykk{ystodenn{kisyys-%      *)
        VerstehAlku=873;        (* Yo no compredon alkupaikka ja ...     *)
        VerstehLoppu=898;       (* ... loppupaikka                       *)
        TMLength=10;            (* miten pitk{ msg-string lahetetaan     *)
        SendScoreInterval=52;   (* monenko pisteen "v{lein" viesti lokiin*)
        MinSendedPoints=75;     (* pienin pistem{{r{, josta viesti lokiin*)
        This= ' There is';
        HalfPunk=':';
        pr1 = '*>';
        pr2 = 'What? ';
        pr3 = 'What do you wanna do with it? ';
        pr4 = 'Where? ';
        pr5 = 'With what? ';
        pr6 = 'Do you want to be restored to life again? ';
        pr7 = 'At what? ';
        pr8 = 'In what? ';
        pr9 = 'On what? ';
        pr10= 'With whom? ';
        pr11= 'The answer is? ';
        pr12= 'To whom? ';
        pr13= 'Combat>';
        ESC = 27;
        DC2 = 18;
        SUB = 26;
        RUB = 127;
        NAK = 21;
        BS  = 8;
	TAB = 9;
        SP  = 32;
        Question = 63;
 
 
 
 
  TYPE
    { jtv@hut.fi:  Use thins instead of conformant arrays } 
    tString = string (255);


    PersonType  = ARRAY [FirstChrNumber .. HenkiloMaara,0 .. PersonDimension]
                    OF Integer;
 
    StringType  = PACKED ARRAY [1 .. SananPituusBE] OF Char;
 
    PersonNameType=ARRAY [FirstChrNumber .. HenkiloMaara] OF
                    RECORD
                      Nakyy:Boolean;
                      Nimi:StringType;
                      Pituus:Integer;
                    END;
 
 
    MsType      = ARRAY [1 .. MessuVarausMaara] OF
                    PACKED RECORD
                      Koodattu : Boolean;
                      luku  : 0..16383;
                      messu : PACKED ARRAY [1 .. TulostusLeveys] OF Char
                    END;
 
    TravelType  = ARRAY [1 .. MontakoHuonetta, 0 .. MontakoSuuntaa] OF Integer;
 
    VisitType   = ARRAY [1..2,1 .. MontakoHuonetta] OF Integer;
 
    KloType     = ARRAY [1 .. 2] OF Integer;
 
    TavaraType  = ARRAY [1 .. TavaraMaara, 1 .. 4] OF Integer;
    KamaIIType  = ARRAY [1 .. 2, 1 .. TavaraMaara] OF
                    RECORD
                      Nakyy:Boolean;
                      Sana:StringType;
                      Pituus:Integer;
                    END;
 
    Sfile       = FILE OF Integer;
    BalType = -1 .. 1;
    ErrorType = (NotCommand, Ambiguous, EoFile);
    TreePtr = ^tree;
    tree    = RECORD
                SubTree: TreePtr;
                upper, left, right: TreePtr;
                Action: Integer;
                ch: Char;
                Balance: BalType;
                Invisible: Boolean
              END;
    member=^ptr;
    tmlstring = PACKED ARRAY [ 1..10 ] OF Char;
    FiFo = RECORD
             first, last: member
           END;
    ptr = RECORD
            prev, suc: member;
            value: Char
          END;
 
 
VAR
  Terminator: SET OF Char;
  MsgString:tmlstring;
  LineBuf,AtomBuf:FiFo;
  AllCmds,Directions,ThenCmd,Werbit,YesNo,Names,Identity,ToCmd,SayWhat,
  BattleW,EPACmds,MiddleCmds,WithCmd: TreePtr;
  Display: Boolean;
  RingFile: Text;
  SaveFile: Sfile;
  x : ^ Integer;
  MontakoHeratysta,
  nytime, atime,t1me,  (* nytime= nytaika, atime=alkuaika *)
  apuaika,
  alkucpu,
  ScoreSended,
  dummybegin, (* Start save +++++++++++ *)
  MitaTapahtuu,
  MoveDoesNotWork,
  hamatack,
  jokisortuu,
  apu1,
  kuka,
  PalaakoPiippu,
  AmuleFly,
  Tuhat,prompt,
  Loput,
  ApuAikaa,flag16,flag98,
  MistyGoblin,
  ZombVisitTime,
  MitaTuliSanottua,
  SaveWord1,
  PseudoHenkilo,
  PseudoVerbi,
  PseudoObjekti,
  ShadowPaikassa,
  Cmd: Integer;
  Power,
  Minus,
  LaitettiinMaahan,
  Confirm,
  Pelataan,
  NowPlaying,
  PlayAgain,
  Brief,
  Quitting,
  AutoGToimi,
  ViuhkaAvattu,
  SakkiAuki,
  OviAuki,
  Varkaat,
  FishRiddle,
  SnakeRiddle,
  AaniViesti,
  NotWizardHimself,
  PelkuriRaukkaLahtiIsostaSokkelosta,
  LfOrNot,
  FirstTime,
  ReadInFiles,
  KaarmeRiddle,
  VBOn,
  Happening: Boolean;
  VisitThePlace: VisitType; (* 1=k{yntikerrat, 2=mahd. messun numero *)
  Character: PersonType;
  NimiTaulu:PersonNameType;
  Muutos:KamaIIType;
  kamat,
  pedot: TavaraType;
  TravelTable: TravelType;
  kello: KloType;
  dummyend: Integer;
  messut: MsType;
 
 
 
      FUNCTION GetTyp: Integer; Extern;
 
      PROCEDURE tmlIn(VAR s : tmlstring); Extern;
 
      PROCEDURE Dynari; Extern;
 
      PROCEDURE AriDyn; Extern;
 
      PROCEDURE SaveGame(VAR DBeg,DEnd:Integer; VAR S:Sfile); Extern;
 
      PROCEDURE RestoreGame(VAR DBeg,DEnd:Integer; VAR S:Sfile); Extern;
 
      FUNCTION  PlayTime : Integer; Extern;
 
      FUNCTION  Runtime : Integer; Extern;
 
      FUNCTION BEG1N : Boolean; Extern;
 
      (*  jtv@hut.fi : get a integer size random number *)
      FUNCTION GetRandom : Integer; External;
      PROCEDURE InitRandom; External;

      (* Put terminal in RAW mode *)
      PROCEDURE c_tty_mode(mode	: integer); C_language;

PROCEDURE Init_Terminal (How :  Integer);
begin
   if (how = 0) then
      c_tty_mode (0)
   else
     begin
	c_tty_mode (3);	{ CBREAK mode }
	c_tty_mode (5);	{ NO ECHO mode }
	c_tty_mode (7);	{ Save this mode, restored with c_tty_mode (8); }
     end;
end; { Init_Terminal }


PROCEDURE Quit;
begin
   Init_Terminal (0);
   writeln ('LORD is quitting...');
   halt;
end; { Quit }

FUNCTION NextChar: Char;
begin
   Get(Input);

   if ord (Input^) > 128 then
      input^ := chr (ord (Input^) mod 128);

   IF Input^ = Chr (TAB) THEN
      NextChar := ' '
   ELSE
      NextChar := Input^;
end; { NextChar }

FUNCTION RickRandom(x:Integer):Integer;
  BEGIN(* RickRandom / tuottaa satunnaiskokonaislukuja [1..x] *)
     { jtv@hut.fi: Get a real random number, not a runtime kludge
    RickRandom:=((Runtime MOD x) +1)
     }
    RickRandom:=((GetRandom MOD x) +1)
  END(* RickRandom *);
 
 
FUNCTION SpB(x:Integer):Integer; (* antaa luvun x "pituuden" *)
  BEGIN
    IF x=0 THEN x:=1;
    SpB:=Trunc(Ln(Abs(x))/Ln(10.0))+1;
  END;
 
FUNCTION LueLuku:Integer;
  VAR luku:Integer;
      ch  : char;
  BEGIN(* LueLuku *)
    luku:=0;
    ch := NextChar;
    Write(ch);
    WHILE (ch IN ['0'..'9']) DO
      BEGIN
        luku:=luku*10+ord(ch)-Ord('0');
        IF luku>9999999 THEN luku:=61163;
	ch := NextChar;
        Write(ch);
      END(* WHILE *);
      Lueluku:=Luku;
    Writeln;
  END(* LueLuku *);
 
FUNCTION MontakoIhmista(Huone:Integer):Integer;
  VAR s,b:Integer; (* ilmoittaa montako henkil{ on ko. huoneessa *)
  BEGIN(* MontakoIhmista *)
    b:=0;
    FOR s:=FirstChrNumber TO HenkiloMaara DO
      BEGIN
        IF Character[s,Now]=Huone THEN b := b + 1; (* henkil huoneessa *)
        IF Character[s,Now]>MontakoHuonetta (* is{nt{ henkil huoneessa *)
          THEN IF Character[Character[s,Now]-MrX,Now]=Huone THEN b := b + 1;
        MontakoIhmista:=b;
      END(* FOR *);
  END(* MontakoIhmista *);
 
 
FUNCTION OnkoPaikalla(Esine : Integer) : Integer;
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Funktio antaa seuraavat arvot: 0 - esine ei ole paikalla eik{ hallussa *)
(*                                 1 - esine on samassa huoneessa          *)
(*                                 2 - esine on pelaajalla mukana          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
  VAR X1:Integer;
  BEGIN(* OnkoPaikalla *)
    IF Character[Kuka,Now]>MontakoHuonetta
      THEN X1:=Character[Character[Kuka,Now]-MrX,Now]
      ELSE X1:=Character[Kuka,Now];
    IF (Kamat[Esine,1]=X1) OR
       (Kamat[Esine,2]=X1)
      THEN OnkoPaikalla:=1          (* on paikalla             *)
        ELSE
          IF (Kamat[Esine,1]=MrX+Kuka)
            THEN OnkoPaikalla:=2    (* on mukana               *)
              ELSE OnkoPaikalla:=0; (* ei mukana eika paikassa *)
  END(* OnkoPaikalla *);
 
 
 
PROCEDURE SendMsgToLog(viesti: tString {PACKED ARRAY [lo..hi:Integer] OF Char};
		       p : Boolean;pistemaara:integer);
  VAR s,a:Integer;
  PROCEDURE NilString;
    VAR ss:Integer;
    BEGIN(* NilString *)
      FOR ss:=1 TO TMLength DO
        MsgString[ss]:=' ';
    END(* NilString *);
  BEGIN(* SendMsgToLog *)
    NilString;a:= 1; { jtv@hut.fi: Was LO }
    MsgString[2]:=Chr((pistemaara DIV 1000)+ Ord('0'));
    MsgString[3]:=Chr((pistemaara DIV 100)-10*(pistemaara DIV 1000)+Ord('0'));
    MsgString[4]:=Chr((pistemaara DIV 10)-10*(pistemaara DIV 100)+Ord('0'));
    MsgString[5]:=Chr((pistemaara MOD 10)+Ord('0'));
    IF NOT p THEN BEGIN NilString;a:=2; END ELSE a:=7;
    FOR s:=a TO TMLength DO
      IF (s-a+1)<= length (viesti) THEN MsgString[s]:=viesti[s-a+1];
    IF NotWizardHimself THEN TmlIn(MsgString);
  END(* SendMsgToLog *);
 
FUNCTION PisteMaara : Integer;
  VAR ansiot,silmu:Integer;
  BEGIN
    ansiot := 1;
    FOR silmu:=51 TO 77 DO (* vaeltelevat pedot *)
      IF Pedot[silmu,4]<>0 THEN ansiot:=ansiot+12;
    FOR silmu := 1 TO TavaraMaara DO
      BEGIN
        IF (kamat[silmu,1]=301) OR (kamat[silmu,1]=(MrX+kuka))
          THEN ansiot:= ansiot+kamat[silmu,3]
            ELSE IF kamat[silmu,1]>MontakoHuonetta THEN
              IF Character[kamat[silmu,1]-MrX,Now]=(Kuka+MrX)
                THEN ansiot:= ansiot+kamat[silmu,3];
        IF Pedot[silmu,1]<>Pedot[silmu,4]
          THEN ansiot:=ansiot+Pedot[silmu,3];
      END;
    IF TravelTable[48,4] <> 707 THEN ansiot := ansiot+50;
    IF VisitThePlace[1,536] <> 0 THEN ansiot := ansiot+33;
    FOR silmu := 1 TO MontakoHuonetta DO
      IF (VisitThePlace[1,silmu] <> 0) AND (silmu MOD 3 = 0) THEN
        ansiot := ansiot + 1;
    FOR silmu:=FirstChrNumber TO HenkiloMaara DO
      BEGIN
        IF (Character[silmu,Now]=0) AND (Character[silmu,Endurance]<>0)
          THEN ansiot:=ansiot-9;
        IF Character[silmu,Now]>MontakoHuonetta
          THEN ansiot := ansiot + 10;
        IF (Character[silmu,Now]<=MontakoHuonetta) AND
           (Character[silmu,Now]>0)
           THEN IF VisitThePlace[1,Character[silmu,Now]]>0
                  THEN ansiot := ansiot + 3;
      END;
    ansiot:=ansiot-50*montakoheratysta;
    IF PelkuriRaukkaLahtiIsostaSokkelosta THEN ansiot:=ansiot-100;
    IF ansiot>ScoreSended+SendScoreInterval THEN
      BEGIN
        SendMsgToLog('Score',True,Ansiot);
        ScoreSended := ScoreSended + SendScoreInterval;
      END;
    PisteMaara:=Abs(ansiot);
  END;
 
 
PROCEDURE MsCoder(x:Integer);
  VAR silmu:Integer;
  BEGIN(* MsCoder *)
    messut[x].Koodattu:=True;
    FOR silmu:=1 TO TulostusLeveys DO
      messut[x].messu[silmu]:=Chr(Ord(messut[x].messu[silmu])-1);
  END(* MsCoder *);
 
 
 
PROCEDURE Messuja(MitaOut: Integer);
  VAR lower,upper,medium: Integer;      (* silmukka-apumuuttuja *)
      found: Boolean;
  BEGIN(* Messuja *)
    lower := 1;
    upper := MessuVarausMaara;
    found := False;
    REPEAT
      medium := (lower + upper) DIV 2;
      IF MitaOut = messut[medium].luku THEN
        found := True
      ELSE IF MitaOut > messut[medium].luku THEN
        lower := medium + 1
      ELSE
        upper := medium - 1
    UNTIL found OR (lower > upper);
    REPEAT
      medium := medium - 1
    UNTIL messut[medium].luku <> MitaOut;
    medium := medium + 1;
    WHILE MitaOut=messut[medium].luku DO
      BEGIN
        IF NOT messut[medium].Koodattu THEN MsCoder(medium);
        IF LfOrNot=True THEN Writeln(messut[medium].messu)
          ELSE Write(messut[medium].messu);
        medium := medium + 1;
      END(* WHILE *);
    LfOrNot:=True;
  END(* Messuja *);
 
 
PROCEDURE WriteOut(B:Integer);
  BEGIN(* WriteOut *)
    IF B>13 THEN BEGIN
                  Messuja(616);
       		  Quit;
                END;
    CASE B OF
      1:Write(pr1);
      2:Write(pr2);
      3:Write(pr3);
      4:Write(pr4);
      5:Write(pr5);
      6:Write(pr6);
      7:Write(pr7);
      8:Write(pr8);
      9:Write(pr9);
      10:Write(pr10);
      11:Write(pr11);
      12:Write(pr12);
      13:Write(pr13);
    END(* CASE *);
  END(* WriteOut *);
 
 
 
 
 
PROCEDURE StartTulkki(Cmd:Integer);
  BEGIN(* StartTulkki *)
    Minus:=Cmd<0;
    Tuhat:=Abs(Cmd) DIV 1000;
    Loput:=Abs(Cmd) MOD 1000;
  END(* StartTulkki *);
 
 
PROCEDURE HirmuIsoSokkelo;
CONST xbound = 42; ybound =29;HowOften=8;WhatProbability=55;
TYPE
  StringType=PACKED ARRAY [1..xbound] OF Char;
  TauluType=PACKED ARRAY [1..ybound,1..xbound] OF Char;
  sqStats=(il,p,e,l,n,ie,pe,xi,pl,el,pi,pil,iel,pel,pie,px,pelx);
  Status = (Free, Permanent,Exit);
  Square = RECORD
             State: Status ;
           END;
VAR
  Taulu:TauluType;
  Board: ARRAY [1..85, 1..59] OF Square; (* 2x+1,2y+1 *)
  CurX, CurY,x,y: Integer;
  Spelar:Boolean;
  MikaMaa: Integer;
  StepCounter: Integer;
  directions: SET OF Char;
 
  PROCEDURE Print;
 
  VAR i,j:Integer;
  BEGIN
    FOR j := CurY - 1 TO CurY + 1 DO
      BEGIN
        Write('  | ');
        FOR i := CurX - 1 TO CurX + 1 DO
          BEGIN
            IF (i=CurX) AND (j=CurY) THEN (* current pos *)
                Write('Ya ')
            ELSE
              IF (i<>CurX) AND (j<>CurY) THEN
                IF (Board [ CurX, j ].State = Free) OR
                   (Board [ i, CurY ].State = Free) THEN (* can see it *)
                      CASE Board [i, j].State OF
                        Free: Write('   ');
                        exit: Write('== ');
                        Permanent: Write('** ')
                      END
                ELSE
                  Write('** ') (* cannot see it *)
              ELSE
                CASE Board [i, j].State OF
                      Free: Write('   ');
                      Permanent: Write('** ')
                END
          END;
        Writeln('|')
      END;
    IF Board [CurX, CurY].state=exit THEN
      BEGIN
        Kamat[48,1]:=513;
        Character[Kuka,Now]:=513;
        Messuja(617);
        Spelar:=False;
      END
  END;
 
PROCEDURE ComsOut;
  BEGIN(* ComsOut *)
    Messuja(618);
    IF StepCounter>2 THEN print;
  END(* ComsOut *);
 
  PROCEDURE HelpTheIdiot;
  BEGIN
    Messuja(619);
    ComsOut;
  END;
 
  PROCEDURE bb(x,y:Integer);
    BEGIN(* bb *)
      Board[x-1,y-1].state:=permanent;
      Board[x-1,y+1].state:=permanent;
      Board[x+1,y-1].state:=permanent;
      Board[x+1,y+1].state:=permanent;
    END(* bb *);
  PROCEDURE Bi(x,y:Integer);
    BEGIN(* Bi *)
      x:=x*2;
      y:=y*2;
      bb(x,y);
      Board[x+1,y].state:=permanent;
    END(* Bi *);
  PROCEDURE Bp(x,y:Integer);
    BEGIN(* Bp *)
      x:=x*2;
      y:=y*2;
      bb(x,y);
      Board[x,y-1].state:=permanent;
    END(* Bp *);
  PROCEDURE Be(x,y:Integer);
    BEGIN(* Be *)
      x:=x*2;
      y:=y*2;
      bb(x,y);
      Board[x,y+1].state:=permanent;
    END(* Be *);
  PROCEDURE Bl(x,y:Integer);
    BEGIN(* Bl *)
      x:=x*2;
      y:=y*2;
      bb(x,y);
      Board[x-1,y].state:=permanent;
    END(* Bl *);
 
PROCEDURE B(x:Integer;string:stringtype);
  VAR s:Integer;
  BEGIN(* B *)
    FOR s:=1 TO xbound DO
      BEGIN
        Taulu[x,s]:=string[s];
      END(* FOR *);
  END(* B *);
 
 
  PROCEDURE Initialize;
 
  VAR
    i,j: Integer;
    ch: Char;
    chmap: ARRAY [ Char ] OF sqStats;
 
  BEGIN
    B(1,'T==KEKTXTKTKT==YKNE=KE=KEY===YKT=YY=KT===K');
    B(2,'AE==XAAEZUAAL=KUUATKAEKLKL==KALVNAANLVT==Z');
    B(3,'L==YKALKATVL=KH==VALVTVTVE=KAUE=OZUHKNUTKA');
    B(4,'T==VAH=VAL=KTVLKT=VT=VTVT=KAAE=YVAEZLVTZAA');
    B(5,'AE==ZH==S=KAL==VAT=S==VTVEVHS=XAES=VEYVAUU');
    B(6,'H=KTSVTKTXLO==Y=SVE==Y=VT==S==XL==YKEOKH=X');
    B(7,'LKAL=XUAL=KLKTZEY==Y=VEKANT=====KTVLKAAHYK');
    B(8,'EVH=XTYVTKLKAALKL=KL==KALKAEY==KAATKUAUUUA');
    B(9,'NEO=YVLKALKLZL=O=KLKTYVANLSKUEKAULVLKH=XTZ');
    B(10,'LYVNATXLSKANL=XANATVAATVAE=SY=VAE=YKLVTKAA');
    B(11,'NHXAAL==KAAAT=KALVATZLVNAT=YS==O==VL==ZAAA');
    B(12,'AATVLKT=VAHOVTVH==VAUT=VLVNUT=XA=T=XTKAUAU');
    B(13,'LZAT=ZL==VAANLXATYKH=SKE=KAEZT=O=VT=VUUNL*');
    B(14,'TVLVTVT===ZLVTKLVAAL=KL==VATSZTVEYZT=KTVEK');
    B(15,'AE==SKUE=KLY=VAE=VL=XAE=Y=VANUUEKUALKLVTKA');
    B(16,'UT==KL=KNHXAE=VTKNE=KLYKAE=SS==KH=O=S=KAAA');
    B(17,'TVTKATKAAATS===VAAEKLKAALY=KE==SSKAE=KAUHV');
    B(18,'ATVALVAUAAE=Y==KLVTVTVALKANLY=XNEVATKLSYOX');
    B(19,'ALXATKLKAL==OEKL==VES=SXHVHKUEKH==VAAT=VAN');
    B(20,'L=XLVLKLOY=KLKAEYKNT=KT=VTVL==VAT==VHVE==V');
    B(21,'T==KEKANALKLKLO=VLVLXAH==OKTKEKUUT==S==Y=X');
    B(22,'ATKL=ZAALKLKLKAEY=KTKLS=XAAAUNATXLY===KUTK');
    B(23,'UAL=KAAHXLKATVLKANLVHXE==ZALKAAATYSY=KUEZA');
    B(24,'EVTKALSO==VAAT=SVH==VNT==VH=VLSSVATZNH==VU');
    B(25,'TXUALKTVT==VAHY=XAT==VATYYS===KTKUAAAUTKEK');
    B(26,'L=KLKHZTVTXTVAAE=VAT=YVAUANTKNLVUTVLVVTLKA');
    B(27,'T=OXAUAUTVNL=VAT==VANUTVTZAAUL=KTOY==SXEZA');
    B(28,'LKUTO=S=VTSKTKALKT=VATVNALVH==KLVAL====KAA');
    B(29,'>S=VL====VESVUL=VL=XLS=VL==S=XL==S===XEVLV');
    Spelar:=True;
    chmap [ 'A' ] := IL;
    chmap [ 'Y' ] := P;
    chmap [ 'S' ] := E;
    chmap [ 'H' ] := L;
    chmap [ 'O' ] := N;
    chmap [ 'V' ] := IE;
    chmap [ '=' ] := PE;
    chmap [ 'Z' ] := XI;
    chmap [ 'T' ] := PL;
    chmap [ 'L' ] := EL;
    chmap [ 'K' ] := PI;
    chmap [ 'N' ] := PIL;
    chmap [ 'U' ] := IEL;
    chmap [ 'E' ] := PEL;
    chmap [ 'X' ] := PIE;
    chmap [ '*' ] := PX;
    chmap [ '>' ] := PELX;
    StepCounter := 0;
    HelpTheIdiot;
    FOR i:=1 TO 85 DO
      FOR j:=1 TO 59 DO
        board[i,j].state:=Free;
    j := 1;
    WHILE (j <= ybound) DO
      BEGIN
        i := 1;
        WHILE (i <= xbound) DO
          BEGIN
            cH:=taulu[j,i];
            CASE chmap [ ch ] OF
              il:BEGIN BI(I,J); BL(I,J); END;
              p:BP(I,J);
              e:BE(i,j);
              l:BL(I,J);
              n:BEGIN END;
              ie:BEGIN BI(I,J);BE(i,j); END;
              pe:BEGIN BP(I,J); BE(i,j);END;
              XI:BI(I,J);
              PL:BEGIN BP(I,J); BL(I,J);END;
              EL:BEGIN BE(i,j); BL(I,J);END;
              PI:BEGIN BP(I,J); BI(I,J);END;
              PIL:BEGIN BP(I,J);BI(I,J);BL(I,J);  END;
              IEL:BEGIN BI(I,J);BE(i,j);BL(I,J);  END;
              PEL:BEGIN BP(I,J);BE(i,j);BL(I,J);  END;
              PIE:BEGIN BP(I,J);BI(I,J);BE(i,j);  END;
              PX: Board[2*i,2*j].state:=Exit;
              PELX:BEGIN BP(I,J);BE(i,j);BL(I,J);CurX:=2*i;CurY:=2*j;END;
            END(* CASE *);
            i := i + 1;
          END;
        j := j + 1
      END;
    directions := ['N', 'W', 'E', 'S'];
    Messuja(620);
  END;
 
 
  PROCEDURE Move;
 
  VAR
    ch: Char;
 
 
    PROCEDURE Move(ch: Char);
 
    VAR
      dx, dy: -2..2;
 
 
    BEGIN
      dx := 0;
      dy := 0;
      CASE ch OF
        'N': dy := -1;
        'W': dx := -1;
        'E': dx := 1;
        'S': dy := 1;
      END;
      IF (Board [ CurX + dx, CurY + dy ].State = Free) THEN
        BEGIN
          CurX := CurX + 2*dx;
          CurY := CurY + 2*dy;
          IF spelar THEN
            BEGIN
              Messuja(621);
              Print;
            END;
        END
      ELSE
        BEGIN
          Messuja(622);
          print;
        END;
    END;
 
 
 
    PROCEDURE Quit;
 
    BEGIN
      Character[Kuka,Now]:=513;
      PelkuriRaukkaLahtiIsostaSokkelosta:=True;
      Messuja(623);
      Spelar:=False;
    END;
 
 
  BEGIN
    StepCounter := StepCounter + 1;
    Write(StepCounter:SpB(StepCounter),')>');
    ch := NextChar;
    Write(ch);
    IF ch >= 'a' THEN
      ch := Chr(Ord(ch) - (Ord('a') - Ord('A')));
    Writeln;
    IF ch IN directions THEN Move(ch)
      ELSE IF ch = 'C' THEN Quit
        ELSE IF ch = 'P' THEN Print
          ELSE IF (ch = '?') OR (ch = 'H') THEN HelpTheIdiot
            ELSE ComsOut;
  END;
 
BEGIN
  Initialize;
  print;
  WHILE Spelar DO
    BEGIN
      Move;
      IF StepCounter MOD HowOften = 0 THEN
        IF (CurX IN [10..63]) AND (CurY IN [6..50]) THEN
          IF RickRandom(100)<=WhatProbability THEN
            BEGIN
              LfOrNot:=False;
              Messuja(624);
              MikaMaa:=RickRandom(4);
              x:=0;y:=0;
              CASE MikaMaa OF
                1:BEGIN y:=-2;Write('to the north');END;
                2:BEGIN x:=-2;Write('to the west');END;
                3:BEGIN x:=2;Write('to the east');END;
                4:BEGIN y:=2;Write('to the south');END;
              END(* CASE *);
              IF Board[CurX+(x DIV 2),CurY+(y DIV 2)].state=Permanent
                THEN Write(' through the wall..');
              Writeln('.');
              CurX:=CurX+x;CurY:=curY+y;
            END;
    END(* WHILE Spelar *);
  Kello[1]:=Kello[1]+StepCounter;
  Kello[2]:=Kello[2]+StepCounter;
END(* HirmuIsoSokkelo *);
 
 
PROCEDURE Laby;
CONST bound = 20;
TYPE
  sqStats = (Free, Movable, Permanent);
  Square = RECORD
             Exit: Boolean;
             State: sqStats ;
             CASE Sink: Boolean OF
               False: ();
               True: (Depth: Integer)
           END;
  errs= (NoWallToPush, TooMuchToPush, ImmovableWall, CantMoveThere);
VAR
  Board: ARRAY [0..21, 0..21] OF Square;
  CurX, CurY, CurZ: Integer;
  Spelar:Boolean;
  MitenKavi: Integer;
  StepCounter: Integer;
  directions: SET OF Char;
 
  PROCEDURE Print;
  VAR
    i,j: Integer;
  BEGIN
    i:=bound;
    FOR j := CurY - 1 TO CurY + 1 DO
      BEGIN
        Write('  | ');
        FOR i := CurX - 1 TO CurX + 1 DO
          BEGIN
            IF (i=CurX) AND (j=CurY) THEN (* current pos *)
                Write('Ya ')
            ELSE
              IF (i<>CurX) AND (j<>CurY) THEN
                IF (Board [ CurX, j ].State = Free) OR
                   (Board [ i, CurY ].State = Free) THEN (* can see it *)
                      CASE Board [i, j].State OF
                        Free: Write('   ');
                        Movable: Write('() ');
                        Permanent: Write(' ')
                      END
                ELSE
                  Write('?? ') (* cannot see it *)
              ELSE
                CASE Board [i, j].State OF
                      Free: Write('   ');
                      Movable: Write('() ');
                      Permanent: Write(' ')
                END
          END;
        Writeln('|')
      END;
    IF Board [CurX, CurY].Exit THEN
      BEGIN
        IF CurX=5 THEN MitenKavi:=2
          ELSE IF CurX=12 THEN MitenKavi:=5 ELSE MitenKavi:=4;
        Spelar:=False;
      END
  END;
 
PROCEDURE ComsOut;
  BEGIN(* ComsOut *)
    Messuja(625);
    IF StepCounter>2 THEN print;
  END(* ComsOut *);
 
  PROCEDURE HelpTheIdiot;
 
  BEGIN
    Messuja(626);
    ComsOut;
  END;
 
PROCEDURE IniPlaces;
BEGIN
CurX:=7;
CurY:=5;
CurZ:=1;
Board[1,10].State:=Permanent;          Board[1,12].Sink:=True;
Board[1,12].Depth:=    1;              Board[2,5].State:=Permanent;
Board[2,6].Sink:=True;                 Board[2,6].Depth:=    8;
Board[2,7].State:=Permanent;           Board[2,10].State:=Permanent;
Board[2,11].State:=Movable;            Board[2,12].Sink:=True;
Board[2,12].Depth:=    1;              Board[2,14].Sink:=True;
Board[2,14].Depth:=    1;              Board[3,1].State:=Permanent;
Board[3,2].State:=Permanent;           Board[3,3].State:=Permanent;
Board[3,4].State:=Permanent;           Board[3,7].State:=Permanent;
Board[3,8].State:=Permanent;           Board[3,9].State:=Permanent;
Board[3,10].State:=Permanent;          Board[3,11].State:=Permanent;
Board[3,13].State:=Permanent;          Board[3,14].State:=Permanent;
Board[3,15].State:=Permanent;          Board[4,1].State:=Permanent;
Board[4,2].State:=Permanent;           Board[4,4].State:=Permanent;
Board[4,5].State:=Movable;             Board[4,7].State:=Permanent;
Board[4,8].State:=Permanent;           Board[4,11].State:=Movable;
Board[4,12].State:=Movable;            Board[4,15].State:=Permanent;
Board[4,16].State:=Permanent;          Board[4,17].State:=Permanent;
Board[4,18].State:=Permanent;          Board[4,19].State:=Permanent;
Board[5,1].State:=Permanent;           Board[5,5].Sink:=True;
Board[5,5].Depth:=    1;               Board[5,10].State:=Movable;
Board[5,10].Exit:=  True;              Board[5,11].State:=Movable;
Board[5,13].State:=Permanent;          Board[5,17].State:=Movable;
Board[5,19].State:=Permanent;          Board[6,1].State:=Permanent;
Board[6,2].State:=Permanent;           Board[6,4].State:=Movable;
Board[6,7].State:=Movable;             Board[6,8].State:=Movable;
Board[6,10].State:=Movable;            Board[6,16].State:=Permanent;
Board[6,18].State:=Movable;            Board[6,19].State:=Permanent;
Board[7,1].State:=Permanent;           Board[7,4].State:=Permanent;
Board[7,6].State:=Permanent;           Board[7,12].State:=Movable;
Board[7,13].State:=Movable;            Board[7,15].State:=Permanent;
Board[7,16].Sink:=True;                Board[7,16].Depth:=    1;
Board[7,19].State:=Permanent;          Board[8,2].State:=Permanent;
Board[8,5].State:=Movable;             Board[8,6].State:=Movable;
Board[8,7].State:=Movable;             Board[8,9].State:=Permanent;
Board[8,13].State:=Permanent;          Board[8,14].State:=Permanent;
Board[8,16].State:=Permanent;          Board[8,18].State:=Movable;
Board[8,19].State:=Permanent;          Board[9,1].State:=Permanent;
Board[9,3].Sink:=True;                 Board[9,3].Depth:=    1;
Board[9,9].State:=Movable;             Board[9,12].State:=Movable;
Board[9,14].State:=Permanent;          Board[9,16].State:=Permanent;
Board[9,17].State:=Movable;            Board[9,19].State:=Permanent;
Board[10,1].State:=Permanent;          Board[10,3].State:=Permanent;
Board[10,7].State:=Permanent;          Board[10,9].State:=Permanent;
Board[10,13].State:=Permanent;         Board[10,14].State:=Permanent;
Board[10,16].State:=Permanent;         Board[10,19].State:=Permanent;
Board[11,1].State:=Permanent;          Board[11,3].State:=Permanent;
Board[11,4].State:=Permanent;          Board[11,8].State:=Permanent;
Board[11,9].State:=Permanent;          Board[11,10].State:=Permanent;
Board[11,11].State:=Permanent;         Board[11,16].State:=Permanent;
Board[11,17].State:=Permanent;         Board[11,19].State:=Permanent;
Board[11,20].State:=Permanent;         Board[12,1].Sink:=True;
Board[12,1].Depth:=   10;              Board[12,5].State:=Permanent;
Board[12,6].Sink:=True;                Board[12,6].Depth:=    1;
Board[12,7].State:=Movable;            Board[12,8].State:=Permanent;
Board[12,9].State:=Permanent;          Board[12,11].State:=Movable;
Board[12,12].State:=Movable;           Board[12,12].Sink:=True;
Board[12,12].Depth:=    3;             Board[12,17].State:=Movable;
Board[12,18].Sink:=True;               Board[12,18].Depth:=    1;
Board[12,19].State:=Movable;           Board[12,19].Sink:=True;
Board[12,19].Depth:=    1;             Board[12,20].State:=Movable;
Board[12,20].Exit:=  True;             Board[13,1].State:=Permanent;
Board[13,2].State:=Movable;            Board[13,2].Exit:=  True;
Board[13,6].Sink:=True;                Board[13,6].Depth:=    1;
Board[13,7].Sink:=True;                Board[13,7].Depth:=    1;
Board[13,9].State:=Permanent;          Board[13,12].State:=Movable;
Board[13,14].State:=Permanent;         Board[13,16].State:=Permanent;
Board[13,17].State:=Permanent;         Board[13,18].State:=Permanent;
Board[13,19].State:=Permanent;         Board[13,20].State:=Permanent;
Board[14,1].Sink:=True;                Board[14,1].Depth:=    1;
Board[14,2].State:=Movable;            Board[14,4].State:=Movable;
Board[14,5].State:=Movable;            Board[14,12].State:=Movable;
Board[14,14].State:=Permanent;         Board[14,15].State:=Permanent;
Board[15,1].State:=Permanent;          Board[15,2].State:=Permanent;
Board[15,3].State:=Permanent;          Board[15,4].State:=Permanent;
Board[15,5].State:=Permanent;          Board[15,6].State:=Permanent;
Board[15,7].State:=Permanent;          Board[15,8].State:=Permanent;
Board[15,9].State:=Permanent;          Board[15,10].State:=Permanent;
Board[15,11].State:=Permanent;         Board[15,12].State:=Permanent;
Board[15,13].State:=Permanent;         Board[15,14].State:=Permanent;
END;
 
 
  PROCEDURE Initialize;
 
  VAR
    i,j, k: Integer;
    ch: Char;
    chmap: ARRAY [ Char ] OF sqStats;
 
  BEGIN
    Spelar:=True;
    FOR ch := Chr(0) TO Chr(127) DO
      chmap [ ch ] := Free;
    chmap [ 'M' ] := Permanent;
    chmap [ 'S' ] := Movable;
    StepCounter := 0;
    HelpTheIdiot;
    i := 1;
    k := 1;
    WHILE (i <= bound) DO
      BEGIN
        j := 1;
        WHILE (j <= bound) DO
          BEGIN
            Board [i, j].State := Free;
            Board [i, j].Exit  := False;
            Board [i, j].Sink  := False;
            j := j + 1;
          END;
        i := i + 1;
      END;
    FOR i:=0 TO 21 DO
      BEGIN
        Board[i,0].State:=Permanent;
        Board[i,0].Exit:=False;
        Board[i,0].Sink:=False;
        Board[i,21].State:=Permanent;
        Board[i,21].Exit:=False;
        Board[i,21].Sink:=False;
        Board[0,i].State:=Permanent;
        Board[0,i].Exit:=False;
        Board[0,i].Sink:=False;
        Board[21,i].State:=Permanent;
        Board[21,i].Exit:=False;
        Board[21,i].Sink:=False;
      END;
    IniPlaces;
    directions := ['N', 'W', 'E', 'S'];
    Messuja(620);
  END;
 
 
  PROCEDURE Move;
 
  VAR
    ch: Char;
 
    PROCEDURE Error(Stupidity: errs);
 
    BEGIN
      LfOrNot:=False;
      CASE Stupidity OF
        NoWallToPush: Messuja(627);
        TooMuchToPush:Messuja(628);
        ImmovableWall:Messuja(629);
        CantMoveThere:Messuja(630);
      END;
      Writeln(' |', Chr(7));
      print;
    END;
 
 
 
    PROCEDURE Move(ch: Char);
 
    VAR
      dx, dy, dz: -1..1;
 
 
    BEGIN
      dx := 0;
      dy := 0;
      dz := 0;
      CASE ch OF
        'N': dy := -1;
        'W': dx := -1;
        'E': dx := 1;
        'S': dy := 1;
      END;
      IF (Board [ CurX + dx, CurY + dy ].State = Free) THEN
        BEGIN
          CurX := CurX + dx;
          CurY := CurY + dy;
          IF Board [ CurX, CurY].Sink THEN
            BEGIN
              MitenKavi:=1;
              Spelar:=False;
            END;
          IF spelar THEN
            BEGIN
              Messuja(621);
              Print;
            END;
        END
      ELSE
        Error(CantMoveThere)
    END;
 
 
 
    PROCEDURE Quit;
 
    BEGIN
      MitenKavi:=0;
      Spelar:=False;
    END;
 
    PROCEDURE Push(ch: Char);
 
    VAR
      dx, dy: -1..1;
 
    BEGIN
      dx := 0;
      dy := 0;
      CASE ch  OF
        'N': dy := -1;
        'W': dx := -1;
        'E': dx := 1;
        'S': dy := 1;
      END;
      IF Board [ CurX + dx, CurY + dy ].State = Movable THEN
        IF Board [ CurX + 2*dx, CurY + 2*dy ].State = Free THEN
          BEGIN
            CurX := CurX + dx;
            CurY := CurY + dy;
            IF NOT Board [ CurX + dx, CurY + dy ].Sink THEN
                Board [ CurX + dx, CurY + dy ].State :=
                          Board [ CurX, CurY ].State
            ELSE
              BEGIN
                Board [ CurX + dx, CurY + dy ].Depth :=
                        Board [ CurX + dx, CurY + dy ].Depth - 1;
                IF Board [ CurX + dx, CurY + dy ].Depth = 0 THEN
                  Board [CurX + dx, CurY + dy ].Sink := False;
              END;
            Board [ CurX, CurY ].State := Free;
            Messuja(631);
            Print;
          END
        ELSE
          Error(TooMuchToPush)
      ELSE
        IF Board [ CurX + dx, CurY + dy ].State = Free THEN
          Error(NoWallToPush)
        ELSE
          Error(ImmovableWall)
    END;
 
 
  BEGIN
    StepCounter := StepCounter + 1;
    Write(StepCounter:SpB(Stepcounter),'>');
    ch := NextChar;
    Write(ch);
    IF ch >= 'a' THEN
      ch := Chr(Ord(ch) - (Ord('a') - Ord('A')));
    IF ch<>'P' THEN Writeln;
    IF ch = 'P' THEN
      BEGIN
	ch := NextChar;
        Write(ch);
        Writeln;
        IF ch >= 'a' THEN
          ch := Chr(Ord(ch) - (Ord('a') - Ord('A')));
        IF ch IN directions
          THEN Push(ch)
            ELSE BEGIN
                   ComsOut;
                   print;
                 END;
      END
    ELSE
      IF ch IN directions THEN
        BEGIN
          Move(ch);
(*        IF Input^ IN directions THEN
            Move(Input^);*)
        END
      ELSE
        IF ch = 'Q' THEN
          Quit
        ELSE
          IF ch = 'L' THEN
            Print
          ELSE
            IF (ch = '?') OR (ch = 'H') THEN
              HelpTheIdiot
          ELSE ComsOut;
  END;
 
BEGIN
  Initialize;
  print;
  WHILE Spelar DO Move;
  Kello[1]:=Kello[1]+StepCounter;
  Kello[2]:=Kello[2]+StepCounter;
  CASE MitenKavi OF
    0:BEGIN
        Messuja(632);
        Character[Kuka,Now]:=503;
      END;
    1:BEGIN
        Messuja(633);
        Character[Kuka,Now]:=503;
      END;
    2:BEGIN
        Messuja(634);
        Character[Kuka,Now]:=56;
        kamat[19,1]:=56;
      END;
    4:BEGIN
        Messuja(635);
        kamat[39,1]:=397;
        Character[Kuka,Now]:=397;
      END;
    5:BEGIN
        Messuja(636);
        kamat[47,1]:=50;
        Character[Kuka,Now]:=50;
      END;
  END(* CASE *);
END; (* Laby *)
 
 
PROCEDURE AikaKuluu(x:Integer);
  BEGIN(* AikaKuluu 1--- komennot  2--- liikkumiset *)
    IF x=2 THEN kello[1] := kello[1] + 1;
    kello[x] := kello[x] + 1;
  END(* AikaKuluu *);
 
 
 
PROCEDURE miu;
  LABEL 1;
  TYPE eskotype=^ufotype;
       ufotype=RECORD
                 C:Char;
                 next:eskotype;
               END;
  VAR first,last:eskotype;
      a:Integer;
      EiIkina:Boolean;
      ch : char;
PROCEDURE outtheory;
  VAR i:eskotype;
  BEGIN(* outtheory *)
    i:=first;
    Write('u');
    WHILE i<>NIL DO
      BEGIN
        Write(i^.C);
        i:=i^.next;
      END(* WHILE *);
    Writeln;
  END(* outtheory *);
PROCEDURE MxI;
  BEGIN(* MxI *)
    IF last^.C='e' THEN
      BEGIN
        New(last^.next);
        last^.next^.C:='o';
        last:=last^.next;
        last^.next:=NIL;
      END
    ELSE
      Messuja(638);
  END(* MxI *);
PROCEDURE Mx;
  VAR i,j,k,l:eskotype;
  BEGIN(* Mx *)
    i:=first^.next;
    New(k);
    j:=k;
    l:=NIL;
    WHILE i<>NIL DO
      BEGIN
        k^.C:=i^.C;
        New(k^.next);
        l:=k;
        k:=k^.next;
        i:=i^.next
      END(* while *);
    last^.next:=j;
    last:=l;
    l^.next:=NIL
  END(* Mx *);
  PROCEDURE III(monEskoI:Integer);
    VAR i,j:eskotype;
        success:Boolean;
    BEGIN(* III *)
      success:=False;
      i:=first;
      j:= NIL;
      WHILE (i<>last) AND (monEskoI>0) DO
        BEGIN
          IF i^.C='e' THEN monEskoI := monEskoI - 1;
          j:=i;
          i:=i^.next;
        END(* WHILE *);
      IF i<>NIL THEN
        IF i^.C='e' THEN
            BEGIN
              i:=i^.next;
              IF i<>NIL THEN
                IF i^.C='e' THEN
                  BEGIN
                    j^.C := 'o';
                    j^.next :=i^.next;
                    success := True;
                  END
            END;
      IF NOT success THEN Messuja(639);
    END(* III *);
PROCEDURE UU(monEskoU:Integer);
  VAR i,j:eskotype;
      success:Boolean;
  BEGIN(* UU *)
    success:=False;
    i:=first;
    j:=NIL;
    WHILE (monEskoU>0) AND (i<>last) DO
      BEGIN
        j:=i;
        i:=i^.next;
        IF i^.C='o' THEN monEskoU := monEskoU - 1;
      END(* WHILE *);
    i:=i^.next;
    IF i<>NIL THEN
      IF i^.C = 'o' THEN
        BEGIN
          j^.next:=i^.next;
          IF j^.next=NIL THEN last:=j;
          success:=True
        END;
    IF NOT success THEN Messuja(890);
  END(* UU *);
  PROCEDURE init;
    BEGIN(* init *)
      New(first);
      first^.C:='F';
      New(first^.next);
      last:=first^.next;
      last^.C:='e';
      last^.next:=NIL;
      EiIkina:=False;
    END(* init *);
  BEGIN(* miu *)
    init;
    Messuja(637);
    REPEAT
      outtheory;
      ch := NextChar;
      IF ch IN ['1'..'6' ] THEN
        CASE ch OF
          '1': MxI;
          '2': Mx;
          '3':BEGIN
                LfOrNot:=False;
                Messuja(640);
                III(Lueluku)
              END;
          '4':BEGIN
                LfOrNot:=False;
                Messuja(641);
                UU(LueLuku)
              END;
          '5':init;
          '6':GOTO 1;
        END(* CASE *)
      ELSE Messuja(637);
    UNTIL EiIkina;
1: END(* miu *);
 
 
 
FUNCTION Search(VAR p: TreePtr; key: Char): Boolean;
 
  BEGIN(* Search *)
    IF p <> NIL THEN
      IF key = p^.Ch THEN
        Search := True
      ELSE
        BEGIN
          IF key < p^.Ch THEN
            p := p^.left
          ELSE
            p := p^.right;
          Search := Search(p, key)
        END
    ELSE
      Search := False
  END(* Search *);
 
PROCEDURE MakeVisible(VAR Cmd: StringType;
            Length: Integer; CmdTree: TreePtr;nakyvaxi:Boolean);
 
  VAR
        i: Integer;
        q: TreePtr;
        Error: Boolean;
 
  BEGIN(* MakeVisible *)
    q := CmdTree;
    i := 1;
    Error := False;
    WHILE NOT Error AND (i <= Length) DO
      BEGIN
        Error := NOT Search(q, Cmd[i]);
        IF NOT Error AND (i<Length) THEN
          q := q^.SubTree;
        i := i + 1
      END(* while *);
    IF NOT Error THEN q^.Invisible := NOT nakyvaxi;(* True => tulee nakyvaxi *)
  END(* MakeVisible *);
 
 
PROCEDURE ObjectsOut(MitaOut: Integer);
  VAR silmu,s : Integer;
      EkaKerta,
      OlikoMitaan: Boolean;
 
  BEGIN(* ObjectsOut *)
    EkaKerta:=False; (* onko tulostettu jo kerran *)
    OlikoMitaan:=False;(* muuttuja joka ilmoittaa oliko jokin esine paikalla *)
 
    CASE MitaOut OF
      1:BEGIN (* inventory *)
          Messuja(155); (* You are carrying: *)
          FOR silmu:=1 TO TavaraMaara DO
            IF Kamat[silmu,1]=MrX+kuka
              THEN
                BEGIN
                  OlikoMitaan:=True;
                  LfOrNot:=False;
                  IF EkaKerta=True THEN Messuja(156);
                  EkaKerta:=True;
                  LfOrNot:=True;
                  Messuja(silmu+KamaKuvaus);
                END;
          IF NOT OlikoMitaan THEN Messuja(157);
        END;
      2:BEGIN
          IF Character[Kuka,RingOn]<>0 THEN Messuja(159); (* a shadow *)
          FOR silmu:=1 TO TavaraMaara DO
           CASE OnkoPaikalla(silmu) OF
             0:IF Muutos[1,silmu].nakyy THEN
                 BEGIN
                   MakeVisible(Muutos[1,silmu].sana,Muutos[1,silmu].pituus,
                               EPACmds,False);
                   Muutos[1,silmu].nakyy:=False;
                 END;
             1:BEGIN
                 IF (Kamat[silmu,1]=Character[Kuka,Now]) AND
                    (NOT (* ne kun ei nay on oltava listassa *)
                     (((silmu-10) IN [3,4,45,47..49,51,66,68..69]) OR
                      ((silmu=66) AND (Character[Kuka,Now]=369)) OR  (* bell *)
                      ((silmu=114) AND (Character[Kuka,Now]=386)) OR
                      ((silmu-100) IN [17..19,21,23,26,27,29,31])))
                   THEN
                     BEGIN
                       Write(This);
                       Messuja(silmu+KamaKuvaus);
                     END;
                 IF NOT Muutos[1,silmu].nakyy THEN
                   BEGIN
                     MakeVisible(Muutos[1,silmu].sana,Muutos[1,silmu].pituus,
                                 EPACmds,True);
                     Muutos[1,silmu].nakyy:=True;
                   END;
               END;
             2:IF NOT Muutos[1,silmu].nakyy THEN
                 BEGIN
                   MakeVisible(Muutos[1,silmu].sana,Muutos[1,silmu].pituus,
                               EPACmds,True);
                   Muutos[1,silmu].nakyy:=True;
                 END;
           END;
        END;
      3:BEGIN
          FOR silmu:=FirstChrNumber TO HenkiloMaara DO
            BEGIN
              IF (Character[silmu,Now]=Character[Kuka,Now]) AND (silmu<>Kuka)
                THEN BEGIN
                       Write(This);
                       Messuja(NameKuvaus+silmu);
                       FOR s:=FirstChrNumber TO HenkiloMaara DO
                         IF Character[s,Now]=silmu+MrX
                           THEN BEGIN
                                  Write('   and');
                                  Messuja(NameKuvaus+s);
                                END;
                       IF NOT NimiTaulu[silmu].nakyy
                         THEN BEGIN
                                NimiTaulu[silmu].nakyy:=True;
                                MakeVisible(NimiTaulu[silmu].nimi,
                                            NimiTaulu[silmu].pituus,
                                            Names,True)
                              END;
                     END;
            END(* FOR *);
          FOR silmu:=1 TO TavaraMaara DO
            IF Pedot[silmu,1]=Character[Kuka,Now]
              THEN
                BEGIN
                  OlikoMitaan:=True;
                  Messuja(silmu+PetoKuvaus);
                  IF NOT Muutos[2,silmu].nakyy THEN (* ei n{y taulussa *)
                   BEGIN
                     MakeVisible(Muutos[2,silmu].sana,Muutos[2,silmu].pituus,
                                 EPACmds,True);
                     Muutos[2,silmu].nakyy:=True;
                   END;
                END
              ELSE IF Muutos[2,silmu].nakyy THEN
                   BEGIN
                     MakeVisible(Muutos[2,silmu].sana,Muutos[2,silmu].pituus,
                                 EPACmds,False);
                     Muutos[2,silmu].nakyy:=False;
                   END;
  END(* ObjectsOut *);END(* CASE MitaOut *);END;
 
PROCEDURE RankingName(Points:Integer);
  BEGIN
    IF Points>=CheaterRaja THEN Messuja(161)
     ELSE IF Points>=GreatWizardRaja THEN Messuja(162)
      ELSE IF Points>=MasterWizardRaja THEN Messuja(163)
       ELSE IF Points>=JuniorWizardRaja THEN Messuja(164)
        ELSE IF Points>=MasterRaja THEN Messuja(165)
         ELSE IF Points>=WinnerRaja THEN Messuja(166)
          ELSE IF Points>=HackerRaja THEN Messuja(167)
           ELSE IF Points>=AdventurerRaja THEN Messuja(168)
            ELSE IF Points>=JuniorAdveRaja THEN Messuja(169)
             ELSE IF Points>=AmateurAdvRaja THEN Messuja(170)
              ELSE IF Points>=NoviceRaja THEN Messuja(171)
               ELSE IF Points>=BeginnerRaja THEN Messuja(172)
                ELSE IF Points>=LoserRaja THEN Messuja(173)
                 ELSE IF Points>=LousyLoser THEN Messuja(174)
                  ELSE IF Points>=FlatHeadRaja THEN Messuja(175)
                   ELSE Messuja(176);
  END(* RankingName *);
 
PROCEDURE Ranking;
    VAR Points:Integer;
    BEGIN
      Points:=PisteMaara;
      Write(' Your actual time in the MWoU is ');
      Write(((PlayTime-atime)DIV 60):SpB((PlayTime-atime)DIV 60));
      Write(' min. and ');
      Write(((PlayTime-atime)MOD 60):SpB((PlayTime-atime)MOD 60));
      Writeln(' sec.');
      Write(' You scored ', Points:SpB(Points), ' out of a possible ');
      Writeln(MaxPiste:SpB(MaxPiste));
      IF (NowPlaying=False) THEN (* loppuherjat *)
        BEGIN
          Write('  by moving ', kello[2]:SpB(kello[2]), ' times, using ');
          Writeln(Kello[1]:SpB(kello[1]),' commands.');
        END;
        LfOrNot:=False;
        Messuja(160);
        RankingName(Points);
    END (*pisteet*);
 
  PROCEDURE InitTrees;
    BEGIN(* InitTrees *)
      AllCmds:=NIL;
      Werbit:=NIL;
      Directions:=NIL;
      ThenCmd:=NIL;
      ToCmd:=NIL;
      SayWhat:=NIL;
      EPACmds:=NIL;
      BattleW:=NIL;
      YesNo:=NIL;
      MiddleCmds:=NIL;
      WithCmd:=NIL;
      Names:=NIL;
      Identity:=NIL;
      terminator := [' ', ',', Chr(ESC)]
    END(* InitTrees *);
 
 
 
  PROCEDURE MakeCmdTree(VAR p: TreePtr; VAR f: Text);
 
    VAR
          h: Boolean;
          Action: Integer;
 
    PROCEDURE Insert(VAR f: Text; act: Integer; VAR p: TreePtr; q: TreePtr;
                     VAR h: Boolean);
 
      VAR
            p1, p2: TreePtr;
            hsub: Boolean;
 
      BEGIN(* Insert *)
        IF p = NIL THEN
          BEGIN
            New(p);
            h := True;
            WITH p^ DO
              BEGIN
                ch := f^;
                upper := q;
                left := NIL;
                right := NIL;
                SubTree := NIL;
                Balance := 0;
                Get(f);
                IF NOT (f^ IN Terminator) THEN
                  BEGIN
                    action := 0;
                    Invisible := False;
                    hsub := False;
                    Insert(f, act, SubTree, p, hsub)
                  END
                ELSE
                  BEGIN
                    action := Abs(act);
                    Invisible := act < 0
                  END;
              END(* with *);
          END (* p = NIL *)
        ELSE IF f^ < p^.Ch THEN
          BEGIN
            Insert(f, act, p^.left, q, h);
            IF h THEN
              CASE p^.Balance OF
                1: BEGIN
                     p^.Balance := 0;
                     h := False
                   END;
                0: p^.Balance := -1;
               -1: BEGIN
                     p1 := p^.left;
                     IF p1^.Balance = -1 THEN
                       BEGIN
                         p^.left := p1^.right;
                         p1^.right := p;
                         p^.Balance := 0;
                         p := p1
                       END
                     ELSE
                       BEGIN
                         p2 := p1^.right;
                         p1^.right := p2^.left;
                         p2^.left := p1;
                         p^.left := p2^.right;
                         p2^.right := p;
                         IF p2^.Balance = -1 THEN p^.Balance := 1
                         ELSE p^.Balance := 0;
                         IF p2^.Balance = 1 THEN p1^.Balance := -1
                         ELSE p1^.Balance := 0;
                         p := p2
                       END;
                     p^.Balance := 0;
                     h := False
                   END
              END(* case *);
          END(* IF f^ < p^.Ch *)
        ELSE IF f^ > p^.Ch THEN
          BEGIN
            Insert(f, act, p^.right, q, h);
            IF h THEN
              CASE p^.Balance OF
               -1: BEGIN
                     p^.Balance := 0;
                     h := False
                   END;
                0: p^.Balance := 1;
                1: BEGIN
                     p1 := p^.right;
                     IF p1^.Balance = 1 THEN
                       BEGIN
                         p^.right := p1^.left;
                         p1^.left := p;
                         p^.Balance := 0;
                         p := p1
                       END
                     ELSE
                       BEGIN
                         p2 := p1^.left;
                         p1^.left := p2^.right;
                         p2^.right := p1;
                         p^.right := p2^.left;
                         p2^.left := p;
                         IF p2^.Balance = 1 THEN p^.Balance := -1
                         ELSE p^.Balance := 0;
                         IF p2^.Balance = -1 THEN p1^.Balance := 1
                         ELSE p1^.Balance := 0;
                         p := p2
                       END;
                     p^.Balance := 0;
                     h := False
                   END
              END(* case *)
          END(* IF f^ > p^.Ch *)
        ELSE
          BEGIN
            h := False;
            Get(f);
            IF NOT (f^ IN Terminator) THEN
              BEGIN
                hsub := False;
                Insert(f, act, p^.SubTree, p, hsub)
              END
            ELSE
              BEGIN
                p^.action := Abs(act);
                p^.Invisible := act < 0
              END
          END
      END(* Insert *);
 
    BEGIN(* MakeCmdTree *)
      (*%Reset(f);*)
      WHILE NOT Eof(f) DO
        BEGIN
          Read(f, action);
          h := False;
          WHILE f^ IN terminator DO
            Get(f);
          Insert(f, action, p, NIL, h);
          Readln(f)
        END(* while *)
    END(* MakeCmdTree *);
 
 
 
 
 
PROCEDURE Parser(CmdTree: TreePtr; PROCEDURE Interpret(VAR cmd: Integer));
 
  VAR
        ChInput: Char;
 
  PROCEDURE GetEbi;
 
    VAR
      ch : char;

    BEGIN(* GetEbi *)
      ch := NextChar;
      IF (ch >= 'a') AND (ch <= 'z') THEN
        ChInput := Chr(ord(ch) - 32)
      ELSE
	 ChInput := ch;
    END(* GetEbi *);
 
  PROCEDURE IntoFiFo(VAR name: FiFo; val: Char);
 
    VAR
          q: member;
 
    BEGIN(* IntoFiFo *)
      IF name.first = NIL THEN
        BEGIN
          New(name.first);
          WITH name.first^ DO
            BEGIN
              prev := NIL;
              suc := NIL;
              value := val
            END(* with *);
          name.last := name.first
        END
      ELSE
        BEGIN
          New(q);
          name.last^.suc := q;
          q^.prev := name.last;
          q^.suc := NIL;
          name.last := q;
          q^.value := val
        END
    END(* IntoFiFo *);
 
  FUNCTION OutFiFo(name: FiFo): Integer;
 
    VAR
          current: member;
          length: Integer;
 
    BEGIN(* OutFiFo *)
      current := name.first;
      length := 0;
      WHILE current <> NIL DO
        BEGIN
          Write(current^.value);
          length := length + 1;
          current := current^.suc
        END(* while *);
      OutFiFo := length
    END(* OutFiFo *);
 
  PROCEDURE AppendFiFo(VAR source, destination: FiFo);
 
    BEGIN(* AppendFiFo *)
      IF source.first <> NIL THEN
        BEGIN
          IF destination.first <> NIL THEN
            BEGIN
              destination.last^.suc := source.first;
              destination.last^.suc^.prev := destination.last;
              destination.last := source.last
            END
          ELSE
            BEGIN
              destination.first := source.first;
              destination.last := source.last
            END;
          source.first := NIL;
          source.last := NIL
        END
    END(* AppendFiFo *);
 
  PROCEDURE KillNode(VAR name: FiFo);
 
    BEGIN(* KillNode *)
      IF name.last <> NIL THEN
        BEGIN
          name.last := name.last^.prev;
          IF name.last = NIL THEN
            name.first := NIL
          ELSE
            name.last^.suc := NIL
        END
    END(* KillNode *);
 
   PROCEDURE MoveWord(VAR source, destination: FiFo);
    VAR   p: member;
          found: Boolean;
    BEGIN
      p := source.last;
      found := False;
      WHILE (p <> NIL) AND NOT found DO
        IF p^.value = ' ' THEN
          found := True
        ELSE
          p := p^.prev;
      destination.last := source.last;
      IF found THEN
        BEGIN
          destination.first := p^.suc;
          IF destination.first <> NIL THEN
            destination.first^.prev := NIL;
          destination.last := source.last;
          source.last := p;
          source.last^.suc := NIL
        END
      ELSE
        AppendFiFo(source, destination)
    END;
 
  FUNCTION ControlU: Integer;
 
    BEGIN(* ControlU *)
      IF Display THEN
        Write(Chr(13))
      ELSE
        Writeln(' XXX');
      ControlU := 0
    END(* ControlU *);
 
  PROCEDURE ControlR;
 
    VAR
          count: Integer;
 
    BEGIN(* ControlR *)
      IF Display THEN
        Write(Chr(13))
      ELSE
        Writeln;
      WriteOut(prompt);
      count := OutFiFo(LineBuf);
      count := OutFiFo(AtomBuf)
    END(* ControlR *);
 
  FUNCTION Error(bug: ErrorType): Integer;
 
    VAR
          count: 0 .. Maxint;
 
    PROCEDURE RubOut;
 
      BEGIN(* RubOut *)
        IF AtomBuf.First <> NIL THEN
          BEGIN
            IF Display THEN
              Write(chr(BS),' ', chr(BS))
            ELSE
              Write('@', AtomBuf.Last^.value);
            KillNode(AtomBuf)
          END
        ELSE IF LineBuf.first <> NIL THEN
          BEGIN
            IF Display THEN
              Write(chr(BS), ' ', chr(BS))
            ELSE
              Write('@', LineBuf.Last^.value);
            KillNode(LineBuf)
          END
        ELSE
          Write(Chr(7))
    END(* RubOut *);
 
    BEGIN(* Error *)
      count := 1;
      CASE bug OF
        NotCommand: BEGIN
                      WHILE NOT (ChInput IN terminator)
		            AND (count > 0)
                            AND NOT Eoln(Input) DO
                        BEGIN
                          GetEbi;
                          IF ord(chinput) = RUB THEN
                            BEGIN
                              count := count - 1;
                              RubOut;
                              IF count = 0 THEN Error := -1
                            END
                          ELSE IF ord(chinput) = NAK THEN
                            BEGIN
                              count := 0;
                              Error := ControlU
                            END
                          ELSE IF ord(chinput) = Question THEN
                            BEGIN
                              Writeln('?');
                              Writeln('Command one of the following:');
                              Writeln('No commands defined for this input');
                              WriteOut(prompt);
 
                              Error := OutFiFo(LineBuf);
                              Error := OutFiFo(AtomBuf)
                            END
                          ELSE IF ord(chinput) = DC2 THEN
                            ControlR
                          ELSE
                            BEGIN
                              Write(chinput);
                              count := count + 1;
                              IntoFiFo(AtomBuf, ChInput)
                            END
                        END;
                      IF count > 0 THEN
                        BEGIN
                          Error := 2;
                          Writeln;
                          Messuja(VerstehAlku+
                                  RickRandom(VerstehLoppu-VerstehAlku+1)-1)
                        END
                    END;
        Ambiguous:  BEGIN
                      Writeln;
                      Error := 2;
                      Writeln('?Ambiguous')
                    END;
        EoFile:     BEGIN
                      Writeln;
                      Error := 2;
                      Writeln('?End of file reached, command line aborted')
                    END;
      END(* case *)
    END(* Error *);
 
  PROCEDURE ParseCmd(CmdTree: TreePtr; VAR cmd: Integer;
                     PROCEDURE Interpret(VAR cmd: Integer));
 
    VAR
          q1, q2: TreePtr;
 
    PROCEDURE RubOut(VAR p, q: TreePtr; VAR cmd: Integer);
 
 
      BEGIN(* RubOut *)
        IF AtomBuf.first <> NIL THEN
          BEGIN
            IF Display THEN
              Write(chr(BS), ' ', chr(BS))
            ELSE
              Write('@', AtomBuf.last^.value);
            IF p^.upper = NIL THEN
              BEGIN
                p := CmdTree;
                q := CmdTree
              END
            ELSE
              BEGIN
                p := p^.upper;
                q := p^.SubTree
              END;
            KillNode(AtomBuf)
          END
        ELSE IF LineBuf.first <> NIL THEN
          BEGIN
            IF Display THEN
              Write(chr(BS), ' ', chr(BS))
            ELSE
              Write('@', LineBuf.last^.value);
            KillNode(LineBuf);
            cmd := 1;
            MoveWord(LineBuf,AtomBuf)
          END
        ELSE
          BEGIN
            Write(Chr(7));
            cmd := -1
          END
      END(* RubOut *);
 
    PROCEDURE ParseField(VAR p: TreePtr; VAR cmd: Integer;
                         PROCEDURE Interpret(VAR cmd: Integer));
 
      VAR
            q: TreePtr;
            ParseBuf: FiFo;
 
      FUNCTION Recognize(p: TreePtr; VAR q: TreePtr;
                       VAR ParseBuf: FiFo): Integer;
 
        VAR
              count: 0 .. Maxint;
 
        BEGIN(* Recognize *)
          IF p = NIL THEN
            Recognize := Error(NotCommand)
          ELSE IF (p^.action <> 0) AND (NOT p^.Invisible OR
                                        (ParseBuf.first = NIL)) THEN
            BEGIN
              count := OutFiFo(ParseBuf);
              AppendFiFo(ParseBuf, AtomBuf);
              Recognize := p^.action;
              q := p
            END
          ELSE IF p^.invisible THEN
            Recognize := Error(NotCommand)
          ELSE IF (p^.SubTree^.left = NIL) AND
                  (p^.SubTree^.right = NIL) THEN
            BEGIN
              IntoFiFo(ParseBuf, p^.SubTree^.Ch);
              Recognize := Recognize(p^.SubTree, q, ParseBuf)
            END
          ELSE
            BEGIN
              count := OutFiFo(ParseBuf);
              q := p;
              Recognize := -1;
              AppendFiFo(ParseBuf, AtomBuf)
            END
        END(* Recognize *);
 
      BEGIN(* ParseField *)
        ParseBuf.first := NIL;
        ParseBuf.last := NIL;
        IF AtomBuf.first <> NIL THEN
          BEGIN
            q := p;
            cmd := Recognize(p, q, ParseBuf);
            p := q;
            IF Abs(cmd) > 2 THEN
              BEGIN
                IF (ChInput IN terminator) and not eoln (Input) THEN
                  BEGIN
                    Write(' ');
                    IntoFiFo(AtomBuf, ' ')
                  END
                ELSE
                  BEGIN
                    Writeln;
                    cmd := -cmd
                  END;
                AppendFiFo(AtomBuf, LineBuf);
                Interpret(cmd)
              END
            ELSE
              Write(Chr(7)) (* Bell *)
          END
        ELSE IF Confirm THEN
          IF Eoln(Input) THEN
            BEGIN
              Writeln;
              Cmd:=3
            END
            ELSE Cmd:=Error(NotCommand)
        ELSE
          Write(Chr(7)) (* Bell *)
      END(* ParseField *);
 
    PROCEDURE GiveCommands(q: TreePtr);
 
      VAR
            WordsOutput: 0 .. Maxint;
            wpl: 0 .. Maxint;
            ParseBuf: FiFo;
	    xX	      : ^Integer;
	    CmdLength : Integer;
 
      PROCEDURE HelpUser(p: TreePtr; VAR ParseBuf: FiFo);
 
        VAR
              x: ^Integer;
 
        BEGIN(* HelpUser *)
          IF p <> NIL THEN
            BEGIN
              HelpUser(p^.left, ParseBuf);
              Mark(x);
              IntoFiFo(ParseBuf, p^.Ch);
              IF (p^.action <> 0) AND NOT p^.Invisible THEN
                BEGIN
                  CmdLength := OutFiFo(AtomBuf);
                  CmdLength := CmdLength + OutFiFo(ParseBuf);
                  WordsOutput := WordsOutput + 1;
                  wpl := wpl + 1;
                  IF wpl > 4 THEN
                    BEGIN
                      wpl := 0;
                      Writeln
                    END
                  ELSE
                    IF Odd(CmdLength DIV 8) THEN Write(Chr(9))
                    ELSE Write(Chr(9), Chr(9))
                END(* IF (p^.action <> 0) AND NOT p^.Invisible *);
              HelpUser(p^.SubTree, ParseBuf);
              KillNode(ParseBuf);
              Release(x);
              HelpUser(p^.right, ParseBuf)
            END
        END(* HelpUser *);
 
      BEGIN
        Mark(XX);
        Writeln('?');
        IF q = NIL THEN
          Writeln('Confirm command')
        ELSE
          BEGIN
            Writeln('Command one of the following:');
            wpl := 0;
            ParseBuf.first := NIL;
            ParseBuf.last := NIL;
            WordsOutput := 0;
            HelpUser(q, ParseBuf);
            IF WordsOutput = 0 THEN
              Write('No commands defined for this input');
            Writeln;
            IF NOT q2^.invisible AND (q2^.action<>0) AND (AtomBuf.first<>NIL)
              THEN Writeln('or confirm command')
          END;
        WriteOut(prompt);
        wpl := OutFiFo(LineBuf);
        wpl := OutFiFo(AtomBuf);
        Release(Xx);
      END(* GiveCommands *);
 
    BEGIN(* ParseCmd *)
      AtomBuf.first := NIL;
      AtomBuf.last := NIL;
      cmd := -1;
      q1 := CmdTree;
      q2 := CmdTree;
      WHILE cmd = -1 DO
        BEGIN
          GetEbi;
          IF (ChInput IN terminator) OR Eoln(Input) THEN
            BEGIN
              ParseField(q2, cmd, Interpret);
              IF AtomBuf.first <> NIL THEN
                q1 := q2^.SubTree
            END
          ELSE IF ord(chinput) = Question THEN
            GiveCommands(q1)
          ELSE IF ord(chinput) = RUB THEN
            Rubout(q2, q1, cmd)
          ELSE IF ord(chinput) = SUB THEN
            cmd := Error(EoFile)
          ELSE IF ord(chinput) = NAK THEN
            cmd := ControlU
          ELSE IF ord(chinput) = DC2 THEN
            ControlR
          ELSE
            BEGIN
              Write(chinput);
              IntoFiFo(AtomBuf, ChInput);
              IF q1 = NIL THEN
                cmd := Error(NotCommand)
              ELSE
                BEGIN
                  q2 := q1;
                  IF search(q2, ChInput) THEN
                    q1 := q2^.SubTree
                  ELSE
                    BEGIN
                      IF q1^.upper <> NIL THEN
                        q2 := q1^.upper
                      ELSE
                        q2 := CmdTree;
                      cmd := Error(NotCommand)
                    END
                END
            END
        END(* while *);
      IF cmd = 1 THEN cmd := -1
    END(* ParseCmd *);
BEGIN
  IF Cmd = 0 THEN WriteOut(prompt);
  ParseCmd(cmdtree,cmd,interpret)
END; { Parser }

 
PROCEDURE N1L(VAR Cmd:Integer);
  BEGIN(* N1L *)
        Cmd := Cmd;
  END(* N1L *);
 
FUNCTION Return:Boolean;
  BEGIN(* Return *)
    Confirm:=True;
    Cmd := 1;
    Parser(NIL,N1L);
    Confirm:=False;
    Return:=Cmd=3
  END(* Return *);
 
PROCEDURE Move(xxx:Integer);VAR EiKompassia:Boolean;
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(* Aliohjelma yritt{{ siirt{{ pelaajaa h{nen haluamaansa suuntaan.         *)
(* Jos TravelTable[ pelaajan sijainti, haluttu suunta ] on pienempi        *)
(* kuin huoneiden enimm{ism{{r{, siirret{{n pelaaja ko. paikkaan,          *)
(* asetetaan MoveDoesNotWork nollaksi, jotta tiedet{{n liikkumisen         *)
(* onnistuneen, sek{ lis{t{{n 'paikassa vierailu'-taulukkoa yhdell{.       *)
(* Muuten em. TravelTablen kohta sis{lt{{ osuvan liikkumisvirheilmoituksen *)
(* tunnisteen. Lopuksi annetaan pelaajalle tietoa siit{, miten k{vi.       *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
  BEGIN(* Move *)
    EiKompassia:=False;
    IF (kamat[85,1]>MontakoHuonetta) THEN (* haltija ei samassa paikassa *)
      IF (Character[kamat[85,1]-MrX,Now]>MontakoHuonetta) THEN
        IF Character[Character[kamat[85,1]-MrX,Now]-MrX,Now]<>
           Character[Kuka,Now] THEN EiKompassia:=True;
    IF ((OnkoPaikalla(85)<>2) AND (* ei kompassia mukana *)
        EiKompassia and (* ei kavereillakaan *)
        (Character[Kuka,Leader]=0)) AND (* ei johtaja *)
        (xxx IN [1..8]) THEN (* ja liikkuminen oli ilmansuuntaan *)
      BEGIN
        Messuja(746);
        xxx:=RickRandom(8);
      END;
    IF TravelTable[Character[Kuka,Now],Xxx] <= MontakoHuonetta THEN
      BEGIN
        Character[Kuka,Before]:=Character[Kuka,Now];
        Character[Kuka,Now] := TravelTable[Character[Kuka,Now],Xxx];
        MoveDoesNotWork := 0; (* nollataan, jotta tiedetaan liikutun *)
        AikaKuluu(2);
      END
      ELSE
        MoveDoesNotWork := TravelTable[Character[Kuka,Now],Xxx];
    VisitThePlace[1,Character[Kuka,Now]] :=
    VisitThePlace[1,Character[Kuka,Now]]+1;
    IF MoveDoesNotWork = 0
      THEN  (* liikkuminen onnistui => kuvaus *)
        BEGIN
          IF (VisitThePlace[1,Character[Kuka,Now]]=1) AND (Brief=False)
            THEN BEGIN
                   Messuja(Character[Kuka,Now]+PitkaKuvaus);
                   IF VisitThePlace[2,Character[Kuka,Now]]<>0 THEN
                     Messuja(VisitThePlace[2,Character[Kuka,Now]]);
                 END
              ELSE BEGIN
                     IF (Character[Kuka,RingOn]=0) AND NOT Brief
                       THEN BEGIN
                              LfOrNot:=False;
                              Messuja(Kuka+NameKuvaus);
                              Write(HalfPunk);
                            END;
                     Messuja(Character[Kuka,Now]+LyhytKuvaus);
                   END;
          ObjectsOut(3); (* tulostetaan paikassa olevat pedot     *)
          ObjectsOut(2); (* tulostetaan paikassa olevat kamat     *)
        END
      ELSE (* liikkuminen ei onnistunut => herja                            *)
        Messuja(MoveDoesNotWork); (* herjan numero on sama kuin MoveDoes... *)
  END(* Move *);
 
 
PROCEDURE FillWithNulls;
  VAR silmu,s : Integer; (* silmukkamuuttuja *)
 
  BEGIN(* FillWithNulls *)
    FOR silmu := 1 TO MontakoHuonetta DO
      FOR s:=1 TO 2 DO
        VisitThePlace[s,silmu]:=0;
    FOR silmu:=1 TO TavaraMaara DO
     BEGIN
      Muutos[1,silmu].nakyy:=False;
      Muutos[2,silmu].nakyy:=False;
      FOR s:=1 TO 4 DO
        BEGIN
          kamat[silmu,s]:=0;
          pedot[silmu,s]:=0;
        END;
      FOR s:=1 TO SananPituusBE DO
        BEGIN
          Muutos[1,silmu].sana[s]:=Chr(0);
          Muutos[2,silmu].sana[s]:=Chr(0);
        END(* FOR *);
     END(* FOR silmu:=1 TO Tavaramaara*);
    FOR silmu:=FirstChrNumber TO HenkiloMaara DO
      BEGIN
        FOR s:=1 TO PersonDimension DO
          Character[silmu,s]:=0;
        NimiTaulu[silmu].nakyy:=False;
        NimiTaulu[silmu].pituus:=0;
      END;
  END(* FillWithNulls *);
 
 
 
 
PROCEDURE NilLineBuf;
  BEGIN(* NilLineBuf *)
    LineBuf.first:=NIL;
    LineBuf.last:=NIL;
  END(* NilLineBuf *);
 
 
PROCEDURE Lopetus;
  VAR jarkea:Boolean;
  PROCEDURE VielakoPelataan(VAR Cmd:Integer);
    VAR sailo:Integer;
    BEGIN
      StartTulkki(Cmd);
      Sailo:=Loput;
      IF NOT Minus THEN Minus:=Return;
      IF Minus THEN
        Pelataan := Sailo = 29;
      jarkea:=True;
    END(* VielakoPelataan *);
  BEGIN(* Lopetus *)
    jarkea:=False;
    PlayAgain:=True;
    Writeln;
    IF MontakoHeratysta<=MaxHeratys
      THEN BEGIN
             REPEAT
               Cmd := 0;
               NilLineBuf;
               pelataan:=False;
               prompt:=6;
               Parser(YesNo,VielakoPelataan)
             UNTIL jarkea
           END
      ELSE pelataan:=False; (* liian monta heratysta jo *)
 
  END(* Lopetus *);
 
 
PROCEDURE NewGame;
 
  VAR
     s1:Integer;
 
  BEGIN(* NewGame *)
    Messuja(186);
    IF PalaakoPiippu>0 THEN PalaakoPiippu:=-PalaakoPiippu;
    MontakoHeratysta := MontakoHeratysta + 1;
    Messuja(187);
    IF MontakoHeratysta>MaxHeratys
      THEN BEGIN
             Messuja(188);
             pelataan:=False;
             NowPlaying:=False;
           END
        ELSE
          BEGIN
            Messuja(189);
            pelataan:=True;
            NowPlaying:=True;
            Character[Kuka,RingOn]:=0;
            Character[Kuka,Now]:=301;
            Character[Kuka,Load]:=0;
            FOR s1:=1 TO TavaraMaara DO
              BEGIN
                IF (kamat[s1,1]=Character[Kuka,Now]) OR (kamat[s1,1]=Mrx+Kuka)
                 THEN
                  CASE (s1 MOD 4) OF
                    0:kamat[s1,1]:=301;
                    1:kamat[s1,1]:=306;
                    2:kamat[s1,1]:=282;
                    3:kamat[s1,1]:=261;
                  END;
              END(* FOR *);
          END;
  END(* NewGame *);
 
PROCEDURE LueFileet;
  VAR silmu1,silmu2,TunnusLuku:Integer;
  BEGIN(* LueFileet *)
 
  BEGIN(* ReadVerbsFromFile *)
    Writeln('>>Ringve.txt.*');
    InitTrees;
    Reset(RingFile,'new1.txt'); MakeCmdTree(AllCmds,RingFile);
    Reset(RingFile,'new2.txt'); MakeCmdTree(Directions,RingFile);
    Reset(RingFile,'new3.txt'); MakeCmdTree(ThenCmd,RingFile);
    Reset(RingFile,'new4.txt'); MakeCmdTree(EPACmds,RingFile);
    Reset(RingFile,'new5.txt'); MakeCmdTree(SayWhat,RingFile);
    Reset(RingFile,'new6.txt'); MakeCmdTree(MiddleCmds,RingFile);
    Reset(RingFile,'new7.txt'); MakeCmdTree(WithCmd,RingFile);
    Reset(RingFile,'new8.txt'); MakeCmdTree(Werbit,RingFile);
    Reset(RingFile,'new9.txt'); MakeCmdTree(YesNo,RingFile);
    Reset(RingFile,'new10.txt');MakeCmdTree(BattleW,RingFile);
    Reset(RingFile,'new11.txt');MakeCmdTree(Names,RingFile);
    Reset(RingFile,'new12.txt');MakeCmdTree(Identity,RingFile);
    Reset(RingFile,'new13.txt');MakeCmdTree(ToCmd,RingFile);
  END(* ReadVerbsFromFile *);
 
  BEGIN (* ReadMessutFileesta *)
    Writeln('>>Ringms.txt.*');
    Reset(RingFile, 'ringms.txt');
    FOR silmu1:=1 TO MessuVarausMaara DO
      messut[silmu1].luku:=EofMs; (* t{ytet{{n loput... *)
    silmu1:=1;
    REPEAT
      BEGIN
        Read(RingFile, TunnusLuku);
        Messut[silmu1].luku:=TunnusLuku;
        silmu2 := 1;
        WHILE (NOT Eoln(RingFile)) AND (silmu2 <= TulostusLeveys) DO
          BEGIN
            messut[silmu1].messu[silmu2] := RingFile ^;
            silmu2 := silmu2 + 1;
            Get(RingFile);
          END(* WHILE *);
        silmu1 := silmu1 + 1;
      END;
    UNTIL Eof(RingFile) OR (silmu1>MessuVarausMaara)
                      OR (messut[silmu1-1].luku=EofMs);
  END(* ReadMessutFileesta *);
 
  BEGIN(* ReadTravelTable *)
    Writeln('>>Ringtr.txt.*');
    Reset(RingFile, 'ringtr.txt');
    FOR silmu1:=1 TO MontakoHuonetta DO
      BEGIN
        FOR silmu2:=0 TO MontakoSuuntaa DO
          Read(RingFile, TravelTable[silmu1,silmu2]);
        Readln(RingFile);
      END(* FOR *);
  END(* ReadTravelTable *);
 
  END(* LueFileet *);
 
PROCEDURE FishRiddleSolve(VAR Cmd:Integer);
 
  BEGIN(* FishRiddleSolve *)
    Happening:=True;
    StartTulkki(Cmd);
    IF NOT Minus THEN Minus:=Return;
    IF Minus THEN
      IF Abs(Cmd)=2092 THEN
        BEGIN
          Messuja(131);
          FishRiddle:=True;
        END
        ELSE
          BEGIN
            Messuja(132);
            FishRiddle:=True;
            Kamat[35,1]:=0;
            Character[Kuka,MaxLoad]:=0;
            Character[Kuka,Now]:=355;
          END;
  END(* FishRiddleSolve *);
 
PROCEDURE MountainRiddleSolve(VAR Cmd:Integer);
 
  BEGIN(* MountainRiddleSolve *)
    StartTulkki(Cmd);
    IF NOT Minus THEN Minus:=Return;
    IF Minus
      THEN IF (Abs(Cmd)=2091)
        THEN
          BEGIN
           Messuja(153);
           pedot[24,1]:=0;
           SnakeRiddle:=True;
           TravelTable[63,1]:=424;
           TravelTable[63,5]:=524;
           TravelTable[63,6]:=135;
           Happening:=True;
          END
          ELSE
           BEGIN
            Messuja(154);
            SnakeRiddle:=True;
            Happening:=True;
            NowPlaying:=False;
           END;
  END(* MountainRiddleSolve *);
 
PROCEDURE Toimenpide;
  VAR silmu:Integer;
  BEGIN(* Toimenpide *)
    IF (MitaTapahtuu IN [1..13,15..27,30..39]) THEN
      CASE MitaTapahtuu OF
      1:BEGIN
          Messuja(612);
          Messuja(613);
          CASE RickRandom(10) OF
            1: Character[Kuka,Now]:=192;
            2: Character[Kuka,Now]:=172;
            3: Character[Kuka,Now]:=13;
            4: Character[Kuka,Now]:=13;
            5: Character[Kuka,Now]:=333;
            6: Character[Kuka,Now]:=163;
            7: Character[Kuka,Now]:=323;
            8: Character[Kuka,Now]:=306;
            9: Character[Kuka,Now]:=191;
            10:Character[Kuka,Now]:=332;
          END(* CASE *);
          Happening:=True;
        END;
      2:BEGIN
          PalaakoPiippu := PalaakoPiippu + 1;
          IF PalaakoPiippu>TupakkaTappaa
            THEN BEGIN
                   Messuja(614);
                   Happening:=True;
                   NowPlaying:=False;
                   PalaakoPiippu:=TupakkaTappaa-3;
                 END;
        END;
      3:BEGIN
          Messuja(306);
          Varkaat:=True;
          FOR silmu:=1 TO TavaraMaara DO
            IF Kamat[silmu,1]=301 THEN Kamat[silmu,1]:=0;
        END;
      4:BEGIN
          VisitThePlace[1,Character[Kuka,Now]] :=
              VisitThePlace[1,Character[Kuka,Now]] + 1;
          ZombVisitTime := ZombVisitTime + 1;
          LfOrNot:=False;
          Messuja(190);
          IF ZombVisitTime<11
            THEN Messuja(ZombVisitTime+600)
              ELSE BEGIN
                     Messuja(611);
                     NowPlaying:=False;
                     Happening:=True;
                   END;
        END;
      5:BEGIN
          Kamat[72,1]:=387;
          Character[Kuka,Load] := Character[Kuka,Load] - 1;
          Messuja(123);
        END;
      6:BEGIN
          Kamat[72,1]:=387;
          Character[Kuka,Load] := Character[Kuka,Load] - 1;
          Messuja(125);
        END;
      7:BEGIN
          Kamat[72,1]:=387;
          Character[Kuka,Load] := Character[Kuka,Load] - 1;
          Messuja(124);
        END;
      8:BEGIN
          Messuja(126);
          Messuja(127);
          Character[Kuka,Now]:=309;
          Happening:=True;
        END;
      9:BEGIN
          Messuja(126);
          Messuja(128);
          Happening:=True;
          NowPlaying:=False;
        END;
      10:BEGIN
           Messuja(129);
           Happening:=True;
           NowPlaying:=False;
         END;
      11:BEGIN (* goblinit vievat eteisest{ vangit... *)
           Messuja(117);
           Character[Kuka,Now]:=340;
           FOR silmu:=FirstChrNumber TO HenkiloMaara DO
             IF (Character[silmu,Now]=Kuka+MrX) OR (* mukana    *)
                (Character[silmu,Now]=368) THEN    (* eteisessa *)
                  Character[silmu,Now]:=390;       (* Old-Road  *)
           Happening:=True;
         END;
      12:BEGIN
           Kamat[35,1]:=347;
           Messuja(130);
           Happening:=True;
         END;
      13:BEGIN
           Messuja(118);
           Messuja(67);
           LfOrNot:=False;
           Messuja(191);
           NilLineBuf;
           prompt:=11;
           REPEAT
             Cmd:=0;
             Parser(AllCmds,FishRiddleSolve);
           UNTIL FishRiddle;
         END;
      15:BEGIN
           Messuja(133);
           MistyGoblin:=0;
         END;
      16:BEGIN
           MistyGoblin:=1;
           messuja(134);
           Character[Kuka,RingOn]:=0;
           IF OnkoPaikalla(35)=0 THEN
             BEGIN
               messuja(135);
               NowPlaying:=False;
               Happening:=True;
             END
         END;
      17:BEGIN
           messuja(136);
           NowPlaying:=False;
           Happening:=True;
         END;
      18:BEGIN
           IF VisitThePlace[1,Character[Kuka,Now]]<4
             THEN BEGIN
                    VisitThePlace[1,Character[Kuka,Now]]:=5;
                    Messuja(138);
                    Messuja(66);
                    LfOrNot:=False;
                    Messuja(192);
                  END;
         END;
      19:BEGIN
           VisitThePlace[1,Character[Kuka,Now]]:=JokiSortuu-3;
           Messuja(143);
           Happening:=True;
           CASE RickRandom(10) OF
             1: Character[Kuka,Now]:=81;
             2: Character[Kuka,Now]:=175;
             3: Character[Kuka,Now]:=99;
             4: Character[Kuka,Now]:=87;
             5: Character[Kuka,Now]:=179;
             6: Character[Kuka,Now]:=193;
             7: Character[Kuka,Now]:=186;
             8: Character[Kuka,Now]:=80;
             9: Character[Kuka,Now]:=187;
             10:Character[Kuka,Now]:=102;
           END(* CASE *);
         END;
      20:BEGIN
           IF VisitThePlace[1,Character[Kuka,Now]]>=(JokiSortuu-2) THEN
             CASE (JokiSortuu-VisitThePlace[1,Character[Kuka,Now]]) OF
               2:Messuja(140);
               1:Messuja(141);
               0:Messuja(142);
             END(* CASE *);
         END;
      21:BEGIN
           Messuja(148);
           VisitThePlace[1,Character[Kuka,Now]]:=Hamatack-4;
           Happening:=True;
           CASE RickRandom(10) OF
             1: Character[Kuka,Now]:=81;
             2: Character[Kuka,Now]:=175;
             3: Character[Kuka,Now]:=99;
             4: Character[Kuka,Now]:=87;
             5: Character[Kuka,Now]:=179;
             6: Character[Kuka,Now]:=193;
             7: Character[Kuka,Now]:=186;
             8: Character[Kuka,Now]:=80;
             9: Character[Kuka,Now]:=187;
             10:Character[Kuka,Now]:=102;
           END(* CASE *);
         END;
      22:BEGIN
           IF VisitThePlace[1,Character[Kuka,Now]]>=(Hamatack-3) THEN
             CASE (Hamatack-VisitThePlace[1,Character[Kuka,Now]]) OF
               3:Messuja(144);
               2:Messuja(145);
               1:Messuja(146);
               0:Messuja(147);
              -1:BEGIN
                   MitaTapahtuu:=21;
                   Toimenpide;
                 END;
             END(* CASE *);
         END;
      23:BEGIN
           kamat[17,2]:=0;
           TravelTable[192,1]:=380;
           TravelTable[192,7]:= 77;
           Happening:=True;
           Messuja(149);
         END;
      24:BEGIN
           Messuja(122);
           TravelTable[12,4]:=204;
           Happening:=True;
         END;
      25:BEGIN
           Happening:=True;
           TravelTable[35,1]:=365;
           Messuja(150);
         END;
      26:BEGIN
          pedot[1,1]:=0;
          TravelTable[61,5]:= 138;
          TravelTable[138,2]:=290;
          TravelTable[138,3]:=440;
          TravelTable[138,5]:=333;
          Messuja(151);
          Happening:=True;
         END;
      27:BEGIN
           Messuja(152);
           Messuja(61);
           LfOrNot:=False;
           Messuja(193);
           Happening:=True;
           NilLineBuf;
           prompt:=11;
           REPEAT
             Cmd:=0;
             Parser(AllCmds,MountainRiddleSolve);
           UNTIL SnakeRiddle;
         END;
      30:BEGIN
           Happening:=True;
           Messuja(139);
           Pedot[36,1]:=0;
           TravelTable[30,2]:=98;
         END;
      31:BEGIN
           MistyGoblin := MistyGoblin + 1;
           IF Character[Kuka,RingOn]<>0 THEN
             BEGIN
               Messuja(137);
               TravelTable[338,12]:=390;
             END;
         END;
      32:BEGIN
           Messuja(737);
           Happening:=True;
           TravelTable[221,7]:=422;
         END;
      33:BEGIN
           Messuja(738);
           Happening:=True;
           TravelTable[320,6]:=422;
         END;
      34:BEGIN
           Messuja(739);
           Happening:=True;
           TravelTable[506,4]:=320;
           pedot[3,1]:=0;
         END;
      35:BEGIN
           Happening:=True;
           IF Abs(Cmd)=2098 THEN
             BEGIN
               Messuja(743);
               pedot[48,1]:=0;
             END
             ELSE
               BEGIN
                 NowPlaying:=False;
                 Messuja(744);
               END;
         END;
      36:BEGIN
           Messuja(741);
           TravelTable[265,9]:=264;
           Happening:=True;
         END;
      37:BEGIN
           Messuja(745);
           Happening:=True;
           NowPlaying:=False;
         END;
      38:BEGIN
           Messuja(742);
           Happening:=True;
           KaarmeRiddle:=True;
         END;
      39:BEGIN
           Messuja(747);
           kamat[85,1]:=0;
         END;
    END(* CASE *);
  END(* Toimenpide *);
 
 
PROCEDURE ShadowClock;
  VAR apu:Integer;
  BEGIN(* ShadowClock *)
    VisitThePlace[1,399]:=0;
    ShadowPaikassa := ShadowPaikassa + 1;
    apu:=RickRandom(ShadowPaikassa);
    IF (VisitThePlace[2,399]=300) AND (apu>50)
      THEN BEGIN VisitThePlace[2,399]:=297;ShadowPaikassa:=-7;END;
    IF (VisitThePlace[2,399]=299) AND (apu>23)
      THEN VisitThePlace[2,399]:=300;
    IF (VisitThePlace[2,399]=298) AND (apu>15)
      THEN VisitThePlace[2,399]:=299;
    IF (VisitThePlace[2,399]=297) AND (apu>6)
      THEN VisitThePlace[2,399]:=298;
  END(* ShadowClock *);
 
 
PROCEDURE ShadowDancers;
  VAR apu:Integer;
  BEGIN(* ShadowDancers *)
    apu:=(VisitThePlace[2,399]-296); (* valoisuus *)
    IF apu IN [1..4] THEN
      CASE apu OF
        1:BEGIN (* pime{{ => + *)
            NowPlaying:=False;
            ShadowPaikassa:=0;
            Messuja(642);
          END;
        2:BEGIN
            NowPlaying:=False;
            Messuja(643);
          END;
        3:BEGIN
            Messuja(644);
            Character[Kuka,Now]:=398;
          END;
        4:BEGIN END;
      END(* CASE *);
  END(* ShadowDancers *);
 
 
PROCEDURE MirrorTrap;
  VAR s:Integer;
  BEGIN(* MirrorTrap *)
    VisitThePlace[1,389]:=0;
    IF kamat[104,2]<>0 THEN
      BEGIN
        FOR s:=FirstChrNumber TO HenkiloMaara DO
          IF (s<>Kuka) AND (Character[s,Now]>MontakoHuonetta) THEN
            IF Character[s,Now]=MrX+Kuka THEN Character[s,Now]:=0;
      END;
  END(* MirrorTrap *);
 
 
PROCEDURE SilentRoom;
  BEGIN(* SilentRoom *)
    IF MontakoIhmista(433)<8
      THEN BEGIN
            Messuja(645);
            TravelTable[433,3]:=907;
           END
    ELSE IF MontakoIhmista(433)>9
      THEN BEGIN
             Messuja(646);
             Character[Kuka,Now]:=415;
             TravelTable[433,3]:=907;
           END
    ELSE (* 8..9 ihmist{ *)
      BEGIN
        TravelTable[433,3]:=451;
        Messuja(647); (*%*)
        TravelTable[433,3]:=907;
        Writeln(' -=- No visitors before 82-Jun-10, sorry... -=-');
      END;
  END(* SilentRoom *);
 
 
PROCEDURE VanderingBeasts; Forward;
 
PROCEDURE Tarkistus(Milloin:Integer);
  PROCEDURE HyokkaakoKukaan;
    BEGIN(* HyokkaakoKukaan *)
      IF (Milloin=2) AND (* ei keskell{ komentoa *)
         VbOn AND (* Pedot saa hyk{t{ *)
         NotWizardHimself AND (* en ole itse, Pedot kyll{ toimii*)
         (RickRandom(100)<VBTodennakoisyys) AND (* huonoa tuuria... *)
         ((MontakoIhmista(Character[Kuka,Now])>1) OR (* yli 1 immeinen *)
          (Character[Kuka,RingOn]=0)) (* ei sormusta sormessa *)
        THEN VanderingBeasts;
    END(* HyokkaakoKukaan *);
  PROCEDURE SormusKello;
    BEGIN(* SormusKello *)
      IF (Milloin=2) AND (kamat[35,1]>MontakoHuonetta) THEN
        IF Character[kamat[35,1]-MrX,RingOn]<>0 THEN
          BEGIN
            IF Character[kamat[35,1]-MrX,RingRating]<0 THEN
              BEGIN
                NowPlaying:=False;
                Quitting:=True;
                Pelataan:=False;
                Happening:=True;
                Messuja(10);
              END;
            Character[kamat[35,1]-MrX,RingRating]:=
            Character[kamat[35,1]-MrX,RingRating]-1;
          END;
    END(* SormusKello *);
  (* 1: heti komennon luvun j{lkeen ennen toteutusta         *)
  (* 2: k{skyn toteutuxen j{lkeen ennen uuden komennon lukua *)
  BEGIN(* Tarkistus *)
    MitaTapahtuu:=0;
    IF ((Milloin=1) AND ((Character[Kuka,Now] IN [12,30,35,61]) OR
                        ((Character[Kuka,Now]-190) IN [2,4,31]) OR
                        ((Character[Kuka,Now]-250) IN [6,15,29]) OR
                        ((Character[Kuka,Now]-310) IN [6,10,38,42,58,67]) OR
                        ((Character[Kuka,Now]-400) IN [20,41,44]) OR
                        ((Character[Kuka,Now]-500) IN [3,6]))) OR
       ((Milloin=2) AND ((Character[Kuka,Now] IN [13]) OR
                        ((Character[Kuka,Now]-20) IN [10,43,62,71,79]) OR
                        ((Character[Kuka,Now]-100) IN [2,27,65,71]) OR
                        ((Character[Kuka,Now]-180) IN [7,8,11]) OR
                        ((Character[Kuka,Now]-250) IN [6,11,29]) OR
                        ((Character[Kuka,Now]-310) IN [28,29,37,43]) OR
                        ((Character[Kuka,Now]-350) IN [10,13,19,24]) OR
                        ((Character[Kuka,Now]-375) IN [4,14,24]) OR
                        ((Character[Kuka,Now]-400) IN [2,10,33])))
      THEN
      CASE (Character[Kuka,Now]+Milloin*1000) OF
      1012:IF Abs(Cmd)=2077 THEN MitaTapahtuu:=24;
      2013:MakeVisible(Muutos[1,1].sana,Muutos[1,1].pituus,EPACmds,True);
      1030:IF ((Pedot[36,1]=30) AND (Abs(Cmd)=2093)) THEN MitaTapahtuu:=30;
      2030:IF (Pedot[36,1]=30) THEN MitaTapahtuu:=18;
      1035:IF Abs(Cmd)=2089 THEN MitaTapahtuu:=25;
      1061:IF (Abs(Cmd)=2090) AND (Pedot[1,1]=61) THEN MitaTapahtuu:=26;
      2063:IF NOT SnakeRiddle AND (VisitThePlace[1,63]>3)
             THEN MitaTapahtuu:=27;
      2082:IF VisitThePlace[1,82]=1 THEN Messuja(302);
      2091:IF VisitThePlace[1,91]<3 THEN Messuja(301);
      2099:IF VisitThePlace[1,99]<3 THEN Messuja(304);
      2102:IF VisitThePlace[1,103]>Hamatack THEN MitaTapahtuu:=21
             ELSE MitaTapahtuu:=22;
      2127:IF VisitThePlace[1,103]>Hamatack THEN MitaTapahtuu:=21
             ELSE MitaTapahtuu:=22;
      2165:IF VisitThePlace[1,165]<3 THEN Messuja(303);
      2171:IF VisitThePlace[1,171]=1 THEN Messuja(305);
      2187:IF VisitThePlace[1,103]>Hamatack THEN MitaTapahtuu:=21
                                         ELSE MitaTapahtuu:=22;
      2188:IF VisitThePlace[1,188]>JokiSortuu THEN MitaTapahtuu:=19
                                           ELSE MitaTapahtuu:=20;
      2191:IF Pedot[47,1]=191 THEN MitaTapahtuu:=4;
      1192:IF (Kamat[17,2]=192) AND (Abs(Cmd)=1002) THEN MitaTapahtuu:=23;
      1194:IF OnkoPaikalla(72)=2 THEN MitaTapahtuu:=5;
      1316:IF VisitThePlace[1,316]<EagleNotRescue THEN MitaTapahtuu:=8
                                               ELSE MitaTapahtuu:=9;
      1221:IF Abs(Cmd)=2095 THEN MitaTapahtuu:=32;
      1256:IF (pedot[48,1]=256) AND KaarmeRiddle THEN MitaTapahtuu:=35;
      2256:IF pedot[48,1]=256 THEN MitaTapahtuu:=38;
      2261:VBOn:=False;
      1265:IF Abs(Cmd)=2097 THEN MitaTapahtuu:=36;
      1279:MitaTapahtuu:=37;
      2279:MitaTapahtuu:=37;
      1320:IF Abs(Cmd)=2096 THEN MitaTapahtuu:=33;
      2338:IF MistyGoblin=0 THEN MitaTapahtuu:=16
            ELSE IF MistyGoblin<MistyKill THEN MitaTapahtuu:=31
                                            ELSE MitaTapahtuu:=17;
      2339:MitaTapahtuu:=10;
      2347:IF Kamat[35,1]=0 THEN MitaTapahtuu:=12;
      1348:IF PalaakoPiippu<1 THEN MitaTapahtuu:=1;
      1352:IF OviAuki AND NOT Varkaat THEN MitaTapahtuu:=3;
      2353:IF OnkoPaikalla(35)=2 THEN MitaTapahtuu:=15;
      2360:IF NOT FishRiddle THEN MitaTapahtuu:=13;
      2363:VBOn:=False;
      1368:IF VisitThePlace[1,368]>2 THEN MitaTapahtuu:=11;
      2369:IF OnkoPaikalla(66)<>0 THEN kamat[66,2]:=306;
      2374:VBOn:=True;
      1377:IF OnkoPaikalla(72)=2 THEN MitaTapahtuu:=6;
      2379:Messuja(116);
      2389:MirrorTrap;
      2399:ShadowClock;
      2402:ShadowDancers;
      2410:VBOn:=False;
      1420:IF OnkoPaikalla(72)=2 THEN MitaTapahtuu:=5;
      1441:IF OnkoPaikalla(72)=2 THEN MitaTapahtuu:=5;
      2433:SilentRoom;
      1444:IF OnkoPaikalla(72)=2 THEN MitaTapahtuu:=7;
      1503:IF OnkoPaikalla(72)=2 THEN MitaTapahtuu:=5;
      1506:IF (Abs(Cmd)=2094) AND (pedot[3,1]=506) THEN MitaTapahtuu:=34;
    END(* CASE *);
    IF (PalaakoPiippu>0) AND (Milloin=1) THEN MitaTapahtuu:=2;
    IF (OnkoPaikalla(18)=2) AND (OnkoPaikalla(85)=2) THEN MitaTapahtuu:=39;
    AikaKuluu(1); (* komentojen m{{r{ *)
    IF MitaTapahtuu>0 THEN Toimenpide;
    HyokkaakoKukaan;
    SormusKello;
  END(* Tarkistus *);
 
 
 
 
PROCEDURE FighterVerbs(Mitaa,Mille:Integer);
  VAR apu:Integer;
  BEGIN(* FighterVerbs *)
    apu:=Mitaa+Mille;
    Messuja(648);
      (*CASE Mitaa OF
        1: messuja(334);
        2:messuja(335);
        3:messuja(307);
        4:messuja(329);
        5:messuja(338);
        6:Messuja(334);
        7:messuja(346);
        8:Writeln('Escape...');
      END;  CASE  *)
      Mille:=Mille;
  END(* FighterVerbs *);
 
 
PROCEDURE ActionVerbs(TeonSana,Objekti:Integer);
  VAR silmu:Integer;apu:Boolean;
  BEGIN(* ActionVerbs *)
    IF NOT (TeonSana IN [1..12,16..17,21,27,29,30,32,36..39]) THEN Messuja(241)
      ELSE
      CASE TeonSana OF
        01: (* examine *)
          IF OnkoPaikalla(Objekti)=0 THEN Messuja(105)
            ELSE
              IF (Objekti-63)*(Objekti-62)*(Objekti-126)<>0 THEN Messuja(245)
                ELSE IF Objekti=63 THEN Messuja(242)
                ELSE IF Objekti=62 THEN
                  BEGIN
                    IF OnkoPaikalla(62)<>2 THEN messuja(108)
                      ELSE
                        IF ViuhkaAvattu=True THEN Messuja(243)
                          ELSE Messuja(244);
                  END
                ELSE IF Objekti=50 THEN Messuja(272)
                ELSE IF Objekti=126 THEN IF Character[Kuka,Now]=371
                                    THEN Messuja(292) ELSE Messuja(245)
                ELSE Messuja(245);
        02: (* Get *)
          BEGIN
            apu1 := 0;
                CASE OnkoPaikalla(Objekti) OF
                  0: Messuja(105);
                  2: Messuja(110);
                  1:BEGIN
                      IF kamat[Objekti,2]<>0
                        THEN Messuja(kamat[Objekti,4])
                        ELSE
                          IF Character[Kuka,Load]=Character[Kuka,MaxLoad]
                           THEN Messuja(104)
                            ELSE
                              IF ((Objekti-50) IN [5,7,9,10])
                                THEN Messuja(Objekti-50+241)
                                  ELSE
                                    BEGIN
                                      kamat[Objekti, 1] := MrX + kuka;
                                      Character[Kuka,Load] :=
                                       Character[Kuka,Load] + 1;
                                      Messuja(107);
                                    END;
                    END;
                END(* CASE *);
          END; (* get *)
        03: (* drop *)
             CASE OnkoPaikalla(Objekti) OF
               0: Messuja(108);
               1: Messuja(249);
               2:BEGIN
                   IF (Objekti=35) AND (Character[Kuka,RingOn]<>0)
                     THEN Messuja(252)
                     ELSE
                       BEGIN
                         Character[Kuka,Load] := Character[Kuka,Load] - 1;
                         IF Character[Kuka,Now]<=MontakoHuonetta
                           THEN kamat[Objekti, 1] := Character[Kuka,Now]
                             ELSE kamat[Objekti, 1] :=
                               Character[Character[Kuka,Now]-MrX,Now];
                         messuja(109);
                       END;
                 END;
             END(* CASE *);
        04: Messuja(253);
        05: (* open *)
              CASE OnkoPaikalla(Objekti) OF
                0: Messuja(105);
                1: IF Objekti=58
                     THEN IF OviAuki=False
                       THEN BEGIN
                              OviAuki:=True;
                              TravelTable[261,11]:=282;
                              TravelTable[282,12]:=261;
                              Messuja(255); (* aukeni *)
                            END
                       ELSE Messuja(254) (* jo auki *)
                     ELSE Messuja(241); (* ei ovi *)
                2: IF ((Objekti) IN [62,63]) OR (Objekti=100)
                     THEN
                       CASE (Objekti-61) OF
                         1: (* fan *)
                           IF NOT ViuhkaAvattu THEN
                             BEGIN
                               Messuja(255);
                               ViuhkaAvattu:=True;
                               Messuja(259);
                             END
                             ELSE Messuja(254);
                         2: (* sack *)
                           IF pedot[47,1]=Character[Kuka,Now]
                            THEN (* zomb IN 191 *)
                             BEGIN
                               TravelTable[191,5]:=377;
                               TravelTable[191,6]:=444;
                               pedot[47,1]:=0;
                               Messuja(260);
                             END
                             ELSE IF pedot[47,1]=0
                               THEN Messuja(261)
                                 ELSE BEGIN
                                        Messuja(262);
                                        kamat[63,1]:=0;
                                      END;
                         39: (* mede *)
                           BEGIN
                             IF kamat[132,1]<>0
                               THEN Messuja(649)
                               ELSE BEGIN
                                      kamat[132,1]:=Character[Kuka,Now];
                                      Messuja(650);
                                    END;
                           END;
                       END(* CASE *)
                     ELSE Messuja(896);
              END(* CASE *);
        06: Messuja(263);
        07: (* lock *)
              CASE OnkoPaikalla(Objekti) OF
                0: Messuja(105);
                1: IF Objekti=58
                     THEN IF OviAuki
                       THEN BEGIN
                              OviAuki:=False;
                              TravelTable[261,11]:=733;
                              TravelTable[282,12]:=733;
                              Messuja(256)
                            END
                       ELSE Messuja(257)
                     ELSE Messuja(258); (* ei ovi *)
                2: Messuja(258);
              END(* CASE *);
        08: (* off eli sammutus *)
          BEGIN
            IF Objekti<>01 THEN messuja(308)
              ELSE
                CASE OnkoPaikalla(1) OF
                  0:messuja(309);
                  1:messuja(309);
                  2:IF PalaakoPiippu<1 THEN messuja(310)
                      ELSE PalaakoPiippu:=1-PalaakoPiippu;
                END(* CASE *);
          END;
        09: (* wave shake *)
          BEGIN
              CASE OnkoPaikalla(Objekti) OF
                0:messuja(105);
                1:messuja(108);
                2:IF (Objekti=62) AND (pedot[44,1]=Character[Kuka,Now])
                   AND ViuhkaAvattu
                    THEN (* 431 *)
                      BEGIN
                        messuja(311);
                        pedot[44,1]:=0;
                        TravelTable[431,3]:=464;
                        TravelTable[431,6]:=194;
                      END
                      ELSE messuja(201);
              END(* CASE *);
          END;
        10:(* pour *) messuja(329);
        11: (* drink *)messuja(313);
        12: (* eat *)
            IF (Character[Kuka,Now]=306) AND (Objekti=55) THEN
              IF Character[Kuka,MaxLoad]<4
                THEN BEGIN
                       Messuja(314);
                       Character[Kuka,MaxLoad]:=4
                     END
                ELSE
                  BEGIN
                    Messuja(651);
                    Character[Kuka,MaxLoad] :=Character[Kuka,MaxLoad] -1;
                  END
            ELSE messuja(315);
        16: (* Read *)
          IF (Objekti<>61) AND (Objekti<>76) THEN messuja(316)
          ELSE
            CASE Objekti OF
              61:
                IF OnkoPaikalla(61)=0 THEN messuja(318)
                  ELSE messuja(317);
              76:
                IF OnkoPaikalla(76)=1 THEN messuja(319)
                  ELSE messuja(320);
            END;
        17: (* break *)
          BEGIN
            CASE OnkoPaikalla(Objekti) OF
              0:Messuja(652);
              1:IF Objekti<>114 THEN Messuja(653)
                ELSE (* on peili *)
                  IF (Character[Kuka,Now]=386)
                    THEN BEGIN
                           kamat[104,2]:=0;
                           Messuja(654);
                         END
                    ELSE BEGIN
                           NowPlaying:=False;
                           Messuja(655);
                         END;
              2:BEGIN
                  Messuja(656);
                  kamat[Objekti,1]:=0;
                  Character[Kuka,load]:=Character[Kuka,load]-1;
                END;
            END(* CASE *);
          END;
        21: (* smoke pipe *)
          BEGIN
                CASE OnkoPaikalla(Objekti) OF
                  0:messuja(253);
                  1:messuja(108);
                  2:IF Objekti<>01
                      THEN
                        BEGIN
                          messuja(323);
                          Character[Kuka,Load] := Character[Kuka,Load]-1;
                          kamat[Objekti,1] := 0;
                        END
                      ELSE (* siis piippu *)
                        IF PalaakoPiippu>0 THEN messuja(322)
                          ELSE
                            BEGIN
                              messuja(321);
                              PalaakoPiippu:=1-PalaakoPiippu;
                            END;
                END(* CASE *);
          END;
        27: (* wait something *) messuja(324);
        29: (* wear *)
          IF Objekti<>35 THEN messuja(328)
            ELSE CASE OnkoPaikalla(35) OF
                   0:messuja(326);
                   1:messuja(108);
                   2:IF Character[Kuka,RingOn]<>0 THEN messuja(325)
                     ELSE BEGIN
                            messuja(327);
                            Character[Kuka,RingOn]:=1; (* muut ei enaa nae *)
                            FOR silmu:=FirstChrNumber TO HenkiloMaara DO
                              IF Character[silmu,Now]=Kuka+MrX THEN
                                Character[silmu,Now]:=Character[Kuka,Now];
                          END;
                 END(* CASE *);
        30: (* unwear *)
          IF Objekti<>35 THEN messuja(332)
            ELSE CASE OnkoPaikalla(35) OF
                   0:messuja(326);
                   1:messuja(108);
                   2:IF Character[Kuka,RingOn]=0 THEN messuja(331)
                     ELSE BEGIN
                            messuja(330);
                            Character[Kuka,RingOn]:=0;
                          END;
                 END(* CASE *);
        32: (* peer *)
          IF OnkoPaikalla(Objekti)=0 THEN Messuja(105)
            ELSE IF (Objekti<>50) THEN Messuja(234)
              ELSE Messuja(271);
        36:(*throw*)
           CASE OnkoPaikalla(Objekti) OF
             0:messuja(340);
             1:messuja(249);
             2:IF (Objekti=35) AND (Character[Kuka,RingOn]<>0)
                THEN messuja(341)
                ELSE
                 BEGIN
                  Messuja(342);
                  Character[Kuka,Load] := Character[Kuka,Load] - 1;
                  IF Character[Kuka,Now]<=MontakoHuonetta
                    THEN kamat[Objekti,1]:=Character[Kuka,Now]
                      ELSE kamat[Objekti,1]:=
                        Character[Character[Kuka,Now]-MrX,Now];
                  IF (Character[Kuka,Now]=60) AND (Objekti=71)
                         AND (pedot[46,1]=60) THEN
                   BEGIN
                    pedot[46,1]:=0;
                    TravelTable[60,1]:=285;
                    TravelTable[60,2]:=431;
                    messuja(343);
                   END
                   ELSE
                    IF ((Objekti=30) AND
                        (((Character[Kuka,Now]= 60)AND(pedot[46,1]=60)) OR
                         ((Character[Kuka,Now]=431)AND(pedot[44,1]=431)) OR
                         ((Character[Kuka,Now]= 63)AND(pedot[24,1]=63)) OR
                         ((Character[Kuka,Now]=30)AND(pedot[36,1]=30))))
                       THEN
                        BEGIN
                         messuja(344);
                         kamat[30,1]:=0; (* aiglos tarvatty | *)
                        END
                       ELSE IF (Objekti=30) AND
                               (Character[Kuka,Now]=98) AND
                               (pedot[31,1]=98) THEN (* porcupine *)
                                BEGIN
                                  messuja(345);
                                  TravelTable[98,4]:=531;
                                  TravelTable[98,1]:=46;
                                  pedot[31,1]:=0;
                                END;
                 END;
           END(* CASE OnkoPaikalla(Objekti) *);
        37: (* move *)IF OnkoPaikalla(Objekti)=0
          THEN Messuja(105) ELSE
          BEGIN
            IF (Objekti<>129) THEN Messuja(783)
              ELSE BEGIN
                     IF TravelTable[306,4]<>514 THEN Messuja(330)
                                                ELSE Messuja(760);
                     TravelTable[306,4]:=514;
                     VisitThePlace[2,Character[Kuka,Now]]:=283;
                   END;
          END;
        38: (* pull *)IF OnkoPaikalla(Objekti)=0 THEN Messuja(105) ELSE
          BEGIN
            IF (Objekti<>123) AND (Objekti<>131) THEN Messuja(767)
            ELSE
              CASE Objekti OF
                123:BEGIN
                     IF TravelTable[383,2]<>415 THEN Messuja(294)
                                                ELSE Messuja(296);
                     TravelTable[383,2]:=415;
                     VisitThePlace[2,383]:=295;
                    END;
                131:BEGIN
                      IF TravelTable[382,2]<>396 THEN Messuja(294)
                                                 ELSE Messuja(296);
                      TravelTable[382,2]:=396;
                      VisitThePlace[2,382]:=295;
                    END;
              END(* CASE *);
          END;
        39: (* turn *)
          BEGIN
            IF OnkoPaikalla(Objekti)=0 THEN Messuja(657)
              ELSE IF Objekti<>118 THEN Messuja(658)
                ELSE BEGIN
                       apu:=False;
                       FOR silmu:=FirstChrNumber TO HenkiloMaara DO
                         IF (silmu<>Kuka) AND (* onko muita mukana... *)
                            ((Character[silmu,Now]=Character[Kuka,Now]) OR
                             (Character[silmu,Now]=MrX+Kuka)) THEN apu:=True;
                       IF NOT apu AND (VisitThePlace[2,407]<>291) THEN
                        BEGIN
                          TravelTable[407,3]:=419;
                          Messuja(291);
                          VisitThePlace[2,407]:=291;
                        END
                         ELSE BEGIN
                                TravelTable[403,3]:=700;
                                VisitThePlace[2,407]:=0;
                                NowPlaying:=False;
                                Messuja(290);
                              END;
                     END;
          END;
      END(* CASE *);
END(* ActionVerbs *);
 
 
PROCEDURE PoisWizard;
  VAR silmu1,silmu2:Integer;
  BEGIN(* PoisWizard *)
    Writeln('>>>MSG-coder starting...');
    NotWizardHimself:=True;
    FOR silmu1:=1 TO MessuVarausMaara DO
      BEGIN
       FOR silmu2:=1 TO TulostusLeveys DO
        messut[silmu1].messu[silmu2]:=Chr(Ord(messut[silmu1].messu[silmu2])+1);
        messut[silmu1].koodattu:=False;
      END;
    Writeln('>>>MSG-coder stopped.');
  END(* PoisWizard *);
 
 
PROCEDURE SystemCmd;
  VAR silmup,s: Integer;
      EkaKerta,OlikoMitaan:Boolean;
  BEGIN(* SystemCmd *)
    IF  Loput IN [1..53]  THEN
      CASE Loput OF
        01: BEGIN
              Quitting:=True;
              NowPlaying:=False;
              Messuja(231);
            END;
        02: Ranking;
        03: ObjectsOut(1);
        04: Messuja(100);
        05: Messuja(99);
        06: Messuja(98);
        07: Messuja(Character[Kuka,Now]+LyhytKuvaus);
        08: BEGIN
              Messuja(Character[Kuka,Now]+PitkaKuvaus);
              IF VisitThePlace[2,Character[Kuka,Now]]<>0
                THEN Messuja(VisitThePlace[2,Character[Kuka,Now]]);
              ObjectsOut(3);
              ObjectsOut(2);
            END;
        09: BEGIN  (* b *)
              Brief:=True;
              Messuja(232);
            END;
        10: BEGIN (* unb *)
              Brief:=False;
              Messuja(233);
            END;
        11: (* unlock *)
            IF (Character[Kuka,Now]<>146) AND
               (Character[Kuka,Now]<>271) AND
               (Character[Kuka,Now]<>294) THEN Messuja(234)
             ELSE
              CASE Character[Kuka,Now] OF
                146:
                    IF kamat[5,1]<>(MrX+kuka) THEN
                      Messuja(235)
                    ELSE
                      BEGIN
                        Messuja(236);
                        TravelTable[146,7]:=81;
                      END;
                271:
                    IF flag16=0 THEN Messuja(237)
                                   ELSE Messuja(238);
                294:
                    IF flag16<>0 THEN Messuja(238)
                    ELSE
                      BEGIN
                        TravelTable[294,11]:=271;
                        flag16:=1;
                        Messuja(239);
                      END;
              END;
        12:(*lock*)Messuja(234);
        13: (* autoget *)
           BEGIN
             AutoGToimi:=False;
             FOR silmup := 1 TO TavaraMaara DO
               IF (OnkoPaikalla(silmup)=1) AND
                  (kamat[silmup,2]=0) THEN
                 BEGIN
                   LfOrNot:=False;
                   Messuja(KamaYxKuvaus+silmup);
                   Write(HalfPunk);
                   ActionVerbs(2,silmup);
                   AutoGToimi:=True;
                 END;
             IF NOT AutoGToimi THEN Messuja(240);
           END;
        14:BEGIN
             SendMsgToLog('Save',True,Pistemaara);
             SaveGame(dummybegin,dummyend,SaveFile);
           END;
        15:BEGIN
             RestoreGame(dummybegin,dummyend,SaveFile);
             Messuja(Character[kuka,Now]+PitkaKuvaus);
             IF VisitThePlace[2,Character[Kuka,Now]]<>0
               THEN Messuja(VisitThePlace[2,Character[Kuka,Now]]);
             ObjectsOut(3);
             ObjectsOut(2);
             ObjectsOut(1);
             Ranking;
           END;
        16:BEGIN
             Messuja(121);
             AikaKuluu(1);
             AikaKuluu(1);
             VisitThePlace[1,Character[Kuka,Now]] :=
              VisitThePlace[1,Character[Kuka,Now]] + 3;
             ShadowPaikassa := ShadowPaikassa + 4;
           END;
        17:BEGIN
             AutoGToimi:=False;
             FOR silmup := 1 TO TavaraMaara DO
               IF OnkoPaikalla(silmup)=2 THEN
                 BEGIN
                   LfOrNot:=False;
                   Messuja(KamaYxKuvaus+silmup);
                   Write(HalfPunk);
                   ActionVerbs(3,silmup);
                   AutoGToimi:=True;
                 END;
             IF AutogToimi=False THEN Messuja(268);
           END;
        18:(* PEE *) Messuja(201);
        19:(* JUKI*) IF Character[Kuka,Now]<>531 THEN Messuja(202)
                       ELSE HirmuIsoSokkelo;
        20:(* UFO*) IF Character[Kuka,Now]<>381 THEN
                     BEGIN
                      Messuja(97);
                      LfOrNot:=False;
                      Messuja(194);
                     END ELSE miu;
        21:(* CURSE*) Messuja(896);
        22:(* BLAST*) Messuja(207);
        23:(* BACK*) Messuja(209);
        24:(* MINDSPEECH*) Messuja(211);
        25:(* SCREAM*) Messuja(212);
        26:(* HARSKI*) Messuja(213);
        27:(* TIME*) BEGIN
                       nytime:=PlayTime-atime;
                       apuaikaa:=nytime MOD 60;
                       nytime:=nytime DIV 60;
                       Write(' Your actual time in the MWoU is ',nytime:4);
                       Writeln(' min. and ',apuaikaa:2,' sec.');
                     END;
        28: (* CPU *)
           BEGIN
              Write('  Cpu used ',(runtime DIV 1000):3,'.');
              Writeln((runtime MOD 1000):3,' sec.');
           END;
        29:(* YES*) Messuja(216);
        30:(* NO*) Messuja(217);
        31:(* NABLA*)
           IF Character[Kuka,Now]<>47 THEN Messuja(218)
             ELSE
              IF TravelTable[48,4]=707 THEN (* pois nbl *)
                BEGIN
                  TravelTable[47,5]:=48;
                  TravelTable[47,6]:=46;
                  TravelTable[48,4]:=47;
                  Messuja(219);
                END
              ELSE Messuja(220);
        32:(* 3+3=5 *)BEGIN
                        Messuja(221);
                        NowPlaying:=False;
                      END;
        33:(* 3+3=6*) IF Character[Kuka,Now]= 218 THEN
                        BEGIN
                          TravelTable[218,2]:=536;
                          Messuja(222);
                        END
                        ELSE Messuja(223);
        34:(* PLUGH*) Messuja(210);
        35:(* ODYSSES*) IF Character[Kuka,Now]=60 THEN
                          BEGIN
                            Messuja(225);
                            NowPlaying:=False;
                          END;
        36:(* MOSES*) Messuja(228);
        37:(* =CPU*) Messuja(226);
        38:(* KLO*)BEGIN
                     nytime:=PlayTime;
                     flag98:=(nytime MOD 3600) DIV 60;
                     Write('The clock is ',(nytime DIV 3600):2,':',flag98:2);
                     nytime:=(nytime MOD 3600) MOD 60;
                     Writeln(':',nytime:2);
                   END;
        39:(* TALK*) Messuja(229);
        40:(* A&E*) BEGIN
                      Messuja(659);
                      Character[Kuka,MaxLoad]:=0;
                      FOR silmup:=1 TO TavaraMaara DO
                        IF OnkoPaikalla(silmup)=2 THEN
                          BEGIN
                            LfOrNot:=False;
                            Messuja(KamaYxKuvaus+silmup);
                            Write(HalfPunk);
                            ActionVerbs(3,silmup)
                          END(* FOR *);
                    END;
        41:(* DING *)
             IF Character[Kuka,Now]<>370 THEN Messuja(270)
               ELSE
                 BEGIN
                   Messuja(269);
                   Kamat[66,2]:=0;
                   Character[Kuka,Now]:=208;
                   Messuja(208+PitkaKuvaus);
                   IF VisitThePlace[2,Character[Kuka,Now]]<>0
                     THEN Messuja(VisitThePlace[2,Character[Kuka,Now]]);
                   VisitThePlace[1,208]:=1;
                   ObjectsOut(2);
                   ObjectsOut(3);
                 END;
        42: (* MIDAS *)BEGIN
                         Messuja(899);
                         NowPlaying:=False;
                       END;
        43: (* MORSE *)Messuja(900);
        44:IF NotWizardHimself THEN
             BEGIN
               LfOrNot:=False;
               Messuja(660);
               silmup:=lueluku;
               IF silmup<>0 THEN Messuja(661)
                            ELSE Messuja(662);
             END
           ELSE
           BEGIN (* .B *)
             Silmup:=0;
             LfOrNot:=False;
             Messuja(663);
             silmup:=lueluku;
             IF (Silmup<>0) AND (Silmup<=MontakoHuonetta) THEN BEGIN
                                Writeln;
                                Writeln('OK, new room is ',Silmup:4);
                                Character[Kuka,Now]:=Silmup;
                              END
                              ELSE Writeln('%Error=',Silmup);
           END;
        45: (* WHO *)
           BEGIN
             Messuja(Kuka+NameKuvaus);
             FOR silmup:=FirstChrNumber TO HenkiloMaara DO
               IF Character[silmup,Now]=Kuka+MrX
                 THEN BEGIN
                        Write(' and');
                        Messuja(silmup+NameKuvaus);
                      END;
             Writeln;
           END;
        46:IF Character[Kuka,Now]<>375 THEN Messuja(796) (* Esko *)
            ELSE BEGIN
                   Messuja(212);
                   Character[Kuka,Now]:=376;
                   Messuja(376+PitkaKuvaus);
                 END;
        47:IF Character[Kuka,Now]<>513 THEN Messuja(795) (* Juki *)
             ELSE HirmuIsoSokkelo;
        48: (* knock *)
           IF Character[Kuka,Now]<>208 THEN Messuja(664) ELSE
             IF RickRandom(100)>20 THEN Messuja(665) ELSE
           BEGIN
             Messuja(666);
             Laby;
           END;
        49: (* Load *)
           BEGIN
             EkaKerta:=False;
             OlikoMitaan:=False;
             ObjectsOut(1);
             FOR silmup:=FirstChrNumber TO HenkiloMaara DO
               IF Character[silmup,Now]-MrX=Kuka THEN
                BEGIN
                 LfOrNot:=False;
                 EkaKerta:=False;
                 Messuja(silmup+NameKuvaus);
                 Writeln(' is carrying:');
                 OlikoMitaan:=False;
                 FOR s:=1 TO TavaraMaara DO
                   IF Kamat[s,1]=MrX+silmup THEN
                     BEGIN
                       OlikoMitaan:=True;
                       LfOrNot:=False;
                       IF EkaKerta THEN BEGIN
                                          Write(' ');
                                          Messuja(156);
                                        END;
                       EkaKerta:=True;
                       LfOrNot:=True;
                       Messuja(s+KamaKuvaus);
                     END;
                IF NOT OlikoMitaan THEN Messuja(157);
                END;
           END;
        50: (* diagnose *)
          BEGIN
            IF Character[Kuka,Endurance]=Character[Kuka,NegEndurance]
              THEN Messuja(861) ELSE
              IF Character[Kuka,Endurance]=Character[Kuka,NegEndurance]+1
                THEN Messuja(862) ELSE
                IF Character[Kuka,Endurance]=Character[Kuka,NegEndurance]+2
                  THEN Messuja(862+RickRandom(2)) ELSE
                  IF Character[Kuka,Endurance]=Character[Kuka,NegEndurance]+3
                    THEN Messuja(865) ELSE Messuja(866);
            IF Character[Kuka,NegEndurance]>5
              THEN Messuja(871) ELSE
              IF Character[Kuka,NegEndurance]>2
                THEN Messuja(870) ELSE
                IF Character[Kuka,NegEndurance]>1
                  THEN Messuja(869) ELSE Messuja(868);
          END;
        51: (* thanks *)Messuja(8);
        52: (* disable *)IF NotWizardHimself THEN Messuja(183) ELSE PoisWizard;
        53: (* status *)
            BEGIN
             Writeln;
             Writeln(' ****************************');
             Writeln(' ***  Lord-Status-Report  ***');
             Writeln(' ****************************');
             Writeln;
             Writeln('  uFo -------------- ',NotWizardHimself=False);
             Writeln('  Wizard ----------- ',NotWizardHimself=False);
             s:=0;
             FOR silmup:=1 TO MontakoHuonetta DO
               IF VisitThePlace[1,silmup]<>0 THEN s := s + 1;
             s:=(s*100) DIV MontakoHuonetta;
             Writeln('  Adventured -------  ',s:SpB(s),'% of MWoU.');
             s:=0;
             FOR silmup:=1 TO TavaraMaara DO
               IF (kamat[silmup,1]>MontakoHuonetta) THEN s := s + 1
                  ELSE IF (kamat[silmup,1]>0) THEN
                    IF VisitThePlace[1,kamat[silmup,1]]<>0 THEN s:=s+1;
             s:=(100*s) DIV TavaraMaara;
             Writeln('  Objects ----------  ',s:SpB(s),'% found.');
             silmup:=PisteMaara;
             s:=(100*silmup) DIV MaxPiste;
             Write('  Points ----- ',silmup:4,' = ');
             Writeln(s:SpB(s),'% of possible.');
             s:=MaxPiste-silmup;
             Writeln('  Missing ----------  ',s:SpB(s),' points.');
             Write('  Ranking ---------- ');RankingName(silmup);
             Writeln;
            END;
        END(* CASE *)
  END(* SystemCmd *);
 
 
 
 
PROCEDURE RutinatPois;
  VAR a:Integer;
  BEGIN(* RutinatPois *)
    dummybegin:=0;Dummyend:=0;
    a:=a+Balrog+BarrowWigth+GiantTroll+Saruman+Gollum;
    a:=a+Shelob+LordOfTheNazgul+Gothmog+MouthOfSauron+Nazgul3;
    a:=a+Nazgul4+Nazgul5+Nazgul6+Nazgul7+Nazgul8+Nazgul9+ChiefOfDunlen;
    a:=7;IF a=8 THEN BEGIN Minus:=False;Loput:=0;Tuhat:=8;END;
  END(* RutinatPois *);
 
 
PROCEDURE Alkuluvut;
  VAR si,silmu1,silmu2:Integer;
      ch : char;
  PROCEDURE h(o,o1,o2,o3,o4,o5,o6,o7,o8,o9,o10,o11,o12,o13,o14,o15:Integer;
              nimi: tString {PACKED ARRAY [lo..hi:Integer] OF Char});
    VAR s:Integer;
    BEGIN(* h *)
      Character[o,Now]:=o1;
      Character[o,Before]:=o2;
      Character[o,Morale]:=o3;
      Character[o,Endurance]:=o4;
      Character[o,NegEndurance]:=o5;
      Character[o,RingRating]:=o6;
      Character[o,Capture]:=o7;
      Character[o,Escape]:=o8;
      Character[o,Sorcery]:=o9;
      Character[o,Load]:=o10;
      Character[o,MaxLoad]:=o11;
      Character[o,Leader]:=o12;
      Character[o,Weapon]:=o13;
      Character[o,RingOn]:=o14;
      Character[o,ArmyStrength]:=o15;
      FOR s:= 1 TO length (nimi) DO NimiTaulu[o].nimi[s]:=nimi[s];
      NimiTaulu[o].pituus:=length(nimi);
    END(* h *);
  PROCEDURE t(no,p1,p2,po,ms:Integer;
              tunnus: tString {PACKED ARRAY [lo..hi:Integer] OF Char} );
    VAR s:Integer;
    BEGIN(* t *)
      Kamat[no,1]:=p1;
      Kamat[no,2]:=p2;
      Kamat[no,3]:=po;
      kamat[no,4]:=ms;
      Muutos[1,no].pituus:=length(tunnus);
      FOR s:= 1 TO length(tunnus) DO Muutos[1,no].sana[s]:=tunnus[s];
    END(* t *);
  PROCEDURE p(no,p1,p2,poing,paikka:Integer;
              tunnus: tString {PACKED ARRAY [lo..hi:Integer] OF Char} );
    VAR s:Integer;
    BEGIN(* p *)
      Pedot[no,1]:=p1;
      Pedot[no,2]:=p2;
      Pedot[no,3]:=poing;
      Pedot[no,4]:=paikka;
      Muutos[2,no].pituus:=length (tunnus);
      FOR s:= 1 TO length (tunnus) DO Muutos[2,no].sana[s]:=tunnus[s];
    END(* p *);
  BEGIN(* Alkuluvut *)
    InitRandom;
    Display := GetTyp IN [5, 6, 7, 15, 16];
    FillWithNulls;

    { jtv@hut.fi: Added this for Unix with no save-images,
      so we need to read the files every time
    }
    ReadInFiles:=BEG1N;

    { jtv@hut.fi: BEG1N may return different values each time }
    FirstTime:=BEG1N;

    IF NOT FirstTime THEN
       SendMsgToLog('Starting.',False,0);
    VisitThePlace[2,306]:=282;
    Quitting:=False;
    ShadowPaikassa:=0;
    ScoreSended:=MinSendedPoints;
    VBon:=False;
    Cmd:=0;
    PseudoHenkilo:=0;PseudoObjekti:=0;PseudoVerbi:=0;
    KaarmeRiddle:=False;
    PelkuriRaukkaLahtiIsostaSokkelosta:=False;
    MistyGoblin:=0;
    Confirm:=False;
    LfOrNot:=True;
    MontakoHeratysta:=0;
    PalaakoPiippu:=0;
    ZombVisitTime:=0;
    silmu1:=0;silmu2:=0;
    kello[1]:=0;
    kello[2]:=0;
    FishRiddle:=False;
    SnakeRiddle:=False;
    AmuleFly:=0;
    VisitThePlace[1,AlkuPaikka]:=2; (* ei pitkaa kuvausta *)
    VisitThePlace[2,399]:=297;
    IF FishRiddle THEN RutinatPois;
    Brief:=False;
    Varkaat:=False;
    SakkiAuki:=False;
    OviAuki:=False;
    ViuhkaAvattu:=False;
    pelataan:=True;
    Happening:=False;
    Power:=False;     (* pelaajalla ei viel{ tavaroiden kantovoimaa   *)
    PlayAgain:=False;
    AaniViesti:=False;
    NowPlaying:=True; (* pelataan... *)
    Write('Have you played the LORD before ? ');

    { jtv@hut.fi: This is the first reference to Input^ and causes the
      lazy i/o system of GPC to get the character from Input }
    Writeln(Input^);

    IF FirstTime OR ReadInFiles THEN
      BEGIN
        Writeln('>Reading the files...');
        LueFileet;
        DynAri;
        NotWizardHimself:= NOT ReadInFiles;
        IF NOT (Input^ IN ['b','B']) THEN PoisWizard
          ELSE
            FOR si:=1 TO MessuVarausMaara DO
              messut[si].Koodattu :=True;
	 Pelataan:=ReadInFiles; (* ei pelata; jtv@hut.fi -> tai sitten kyll{ *)
      END;
    AriDyn;
    kuka:=Bilbo;
    h(Thorin,370,370,9,9,9,2,3,6,0,0,8,2,0,0,0,'THORIN');
    h(Nuutila,514,514,3,3,3,0,10,1,0,0,2,0,0,0,0,'NUUTILA');
    h(Dwalin,306,306,7,4,4,0,4,6,0,0,3,0,0,0,0,'DWALIN');
    h(Balin,411,411,7,4,4,0,4,6,0,0,3,0,0,0,0,'BALIN');
    h(Kili,412,412,7,4,4,0,4,6,0,0,3,0,0,0,0,'KILI');
    h(Fili,303,303,7,4,4,0,4,6,0,0,3,0,0,0,0,'FILI');
    h(Dori,531,513,7,4,4,0,4,6,0,0,3,0,0,0,0,'DORI');
    h(Nori,291,291,7,4,4,0,4,6,0,0,3,0,0,0,0,'NORI');
    h(Ori,288,288,7,4,4,0,4,6,0,0,3,0,0,0,0,'ORI');
    h(Oin,13,13,7,4,4,0,4,6,0,0,3,0,0,0,0,'OIN');
    h(Gloin,508,508,7,4,4,0,4,6,0,0,3,0,0,0,0,'GLOIN');
    h(Bifur,204,204,7,4,4,0,4,6,0,0,3,0,0,0,0,'BIFUR');
    h(Bofur,539,539,7,4,4,0,4,6,0,0,3,0,0,0,0,'BOFUR');
    h(Bombur,388,388,7,4,4,0,4,6,0,0,3,0,0,0,0,'BOMBUR');
    h(Aragorn,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'ARAGORN');
    h(Bilbo,AlkuPaikka,AlkuPaikka,8,4,4,10,2,9,0,0,3,0,0,0,0,'BILBO');
    h(Boromir,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'BOROMIR');
    h(Frodo,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'FRODO');
    h(Samwise,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'SAMWISE');
    h(Meriadoc,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'MERIADOC');
    h(Peregrin,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'PEREGRIN');
    h(GandalfGrey,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'GANDALFGREY');
    h(GandalfWhite,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'GANDALFWHITE');
    h(Gimli,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'GIMLI');
    h(Legolas,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'LEGOLAS');
    h(Elrond,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'ELROND');
    h(Galadriel,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'GALADRIEL');
    h(Celeborn,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'CELEBORN');
    h(Thranduil,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'THRANDUIL');
    h(DainII,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'DAINII');
    h(BrandIII,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'BRANDIII');
    h(Denethor,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'DENETHOR');
    h(Faramir,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'FARAMIR');
    h(Imrahil,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'IMRAHIL');
    h(Theoden,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'THEODEN');
    h(Theodred,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'THEODRED');
    h(Eomer,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'EOMER');
    h(Eowyn,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,'EOWYN');
    apuaika:=1; (* seurataan aluksi vain pelkkia komentoja *)
    t1me := PlayTime;
    atime:=t1me; (* pelin aloitusaika sekunneissa vrk:n alusta *)
    alkucpu:= runtime; (* cpu-kulutus pelin alussa *)
(*  kamat[14,1]:=506;
    kamat[14,2]:=506;
    pedot[21,1]:=506;  loput wartijoita *)
(*    pedot[32,1]:=221; *)
    p(1,61,0,0,0,'THURINGWETHIL');
    p(3,506,0,0,0,'DRAUGLUIN');
    p(9,526,0,0,0,'GRAVEGHOST');
    p(17,338,0,0,0,'GOBLIN');
    p(24,63,0,26,63,'COLDSNAKE');
    p(29,348,0,0,0,'FLIES');
    p(31,98,0,25,98,'PORCUPINE');
    p(36,30,0,15,30,'PUKELMAN');
    p(44,431,0,22,431,'SNAPDRAGON');
    p(45,220,0,0,0,'WARRIOR');
    p(46,60,0,7,60,'CYCLOP');
    p(47,191,0,45,191,'ZOMBIE');
    p(48,256,0,0,0,'SMAUG');
    p(49,415,0,0,0,'KALI');
    p(50,402,0,0,0,'DANCER');
    p(51,0,0,0,0,'BANDIT');
    p(52,0,0,0,0,'BERSERKER');
    p(53,0,0,0,0,'BUGBEAR');
    p(54,0,0,0,0,'DOPPLEGANGER');
    p(55,0,0,0,0,'DWARF');
    p(56,0,0,0,0,'GHOUL');
    p(57,0,0,0,0,'GNOLL');
    p(58,0,0,0,0,'HYENA-MAN');
    p(59,0,0,0,0,'GNOME');
    p(60,0,0,0,0,'KOBOLD');
    p(61,0,0,0,0,'LIZARD-MAN');
    p(62,0,0,0,0,'MINOTAUR');
    p(63,0,0,0,0,'MUMMY');
    p(64,0,0,0,0,'OGRE');
    p(65,0,0,0,0,'PIXIE');
    p(66,0,0,0,0,'SKELETON');
    p(67,0,0,0,0,'NANDIE-BEAR');
    p(68,0,0,0,0,'BERBALANG');
    p(69,0,0,0,0,'GU''EN-DEEKO');
    p(70,0,0,0,0,'TROLLKIN');
    p(71,0,0,0,0,'ASSASSIN');
    p(72,0,0,0,0,'ANTICLERIC');
    p(73,0,0,0,0,'DRUID');
    p(74,0,0,0,0,'MONK');
    p(75,0,0,0,0,'TERMAGANT');
    p(76,0,0,0,0,'BANSHEE');
    p(77,0,0,0,0,'SVART');
    t( 1,13,0,1,0,'PIPE');
    t( 5,291,0,1,0,'KEY');
    t(10,22,0,10,0,'KNIFE');
    t(16,260,0,63,0,'STONE');
    t(17,192,192,52,278,'!STONE');
    t(18,274,0,45,0,'%STONE');
    t(19,0,0,38,0,'&STONE');
    t(30,411,0,25,0,'AIGLOS');
    t(36,161,0,31,0,'GOLD-ARROW');
    t(38,118,0,131,0,'SILVER-ARROW');
    t(39,0,0,45,0,'BLUE-ARROW');
    t(42,366,0,1,0,'ELFBOW');
    t(43,491,0,-7,0,'ORCBOW');
    t(47,0,0,131,0,'1.SILMARIL');
    t(48,0,0,520,0,'2.SILMARIL');
    t(50,536,536,0,272,'1.PALANTIR');
    t(55,306,306,0,273,'CAKE');
    t(57,306,306,0,274,'BIER');
    t(58,261,282,0,275,'DOOR');
    t(59,306,306,0,276,'PAN');
    t(61,513,513,0,277,'RUNES');
    t(62,303,0,2,0,'FAN');
    t(63,306,0,0,0,'SACK');
    t(64, 56,0,-20,0,'RUBY');
    t(65,444,0,22,0,'OX');
    t(66,370,370,99,270,'BELL');
    t(67,448,0,19,0,'SILVER');
    t(69,412,0,11,0,'DIAMOND');
    t(70,220,0,12,0,'SAPPHIRE');
    t(71,410,0,1,0,'STICK');
    t(72,387,0,75,0,'AMULET');
    t(76,218,218,0,279,'CLAUSE');
    t(77,203,0,75,0,'ANCHOR');
    t(78,146,146,0,280,'ELVENDOOR');
    t(79,208,208,0,281,'UFO''S-GATE');
    t(80,208,0,131,0,'NIMPHELOS');
    t(81,526,0,112,0,'HELMET');
    t(82,160,0,201,0,'GEM');
    t(83,315,0,52,0,'MAIL');
    t(84,422,0,75,0,'CHAIR');
    t(85,301,0,3,0,'COMPASS');
    t(86,256,0,131,0,'JEWEL');
    t(99,388,0,47,0,'DAGGER');
    t(100,421,0,72,0,'MEDALLION');
    t(101,433,0,112,0,'ONYX');
    t(102,403,0,71,0,'STATUE');
    t(103,419,0,37,0,'STATUETTE');
    t(104,393,393,47,296,'BRACELET');
    t(114,386,389,0,296,' xMIRROR');
    t(117,436,402,0,210,' xALTAR');
    t(118,407,407,0,177,' xWHEEL');
    t(121,436,436,0,182,' xCANDLESTICK');
    t(123,383,383,0,334,' xARM');
    t(126,371,522,0,293,' xBODY ');
    t(127,433,433,0,176,' xGRATE');
    t(129,306,306,0,758,' xSHELF');
    t(131,382,382,0,161,' xDRAPES');
    t(132,0,0,131,0,'STAMP');
    TravelTable[ 12,4]:=723;  (* ankkuri *)
    TravelTable[ 30,2]:=709; (* pukelman *)
    TravelTable[ 35,1]:=722;  (* arwaa kahdeksan kertaa *)
    TravelTable[ 47,5]:=711; (* nabla *)
    TravelTable[ 47,6]:=711;
    TravelTable[ 48,4]:=707;
    TravelTable[ 60,1]:=701; (* cyclo *)
    TravelTable[ 60,2]:=701;
    TravelTable[ 61,5]:=720; (* thuringwethil *)
    TravelTable[ 63,1]:=705; (* coldsna *)
    TravelTable[ 63,5]:=705;
    TravelTable[ 63,6]:=705;
    TravelTable[ 98,1]:=710; (* porcupin *)
    TravelTable[ 98,4]:=710;
    TravelTable[ 99,1]:=726;
    TravelTable[138,2]:=721;
    TravelTable[138,3]:=721;
    TravelTable[138,5]:=721;
    TravelTable[146,7]:=729; (* elvendoor *)
    TravelTable[165,3]:=725;
    TravelTable[171,5]:=727;
    TravelTable[176,4]:=728;
    TravelTable[191,6]:=706;
    TravelTable[191,5]:=706; (* zomb *)
    TravelTable[192,1]:=724;  (* !stone *)
    TravelTable[192,7]:=724;
    TravelTable[218,2]:=707; (* 3+3 & zzzzzzzzzzzz *)
    TravelTable[221,7]:=735; (* UUUUU *)
    TravelTable[221,6]:=728; (* guardit *)
    TravelTable[221,6]:=708; (* ei valmis *)
    TravelTable[261,11]:=733;
    TravelTable[265,9]:=740; (* lonelymountainesto *)
    TravelTable[282,12]:=733;
    TravelTable[294,11]:=729; (* lonelydoor *)
    TravelTable[306,4]:=766;
    TravelTable[320,6]:=736; (* bolwi... *)
    TravelTable[338,12]:=734;
    TravelTable[342,2]:=700; (* eipas paasekkaan Moriaan enaa *)
    TravelTable[363,10]:=703;(* ei alas *)
    TravelTable[375,3]:=766;
    TravelTable[381,1]:=712;
    TravelTable[381,2]:=713;
    TravelTable[381,4]:=713;
    TravelTable[381,9]:=713;
    TravelTable[382,2]:=873;
    TravelTable[383,2]:=902;
    TravelTable[407,3]:=700;
    TravelTable[412,9]:=702; (* ei yls *)
    TravelTable[422,7]:=728;
    TravelTable[431,3]:=704; (* snapdra *)
    TravelTable[431,6]:=704;
    TravelTable[433,3]:=907;
    TravelTable[436,2]:=784; (*%*)
    TravelTable[451,4]:=784; (*%*)
    TravelTable[506,4]:=700; (* draugluin *)
    TravelTable[526,7]:=728;
    IF (Input^ <> 'Y') AND (Input^ <> 'y') AND (NOT FirstTime)
      THEN messuja(RunoTunniste);
    Writeln;
    IF (NOT FirstTime) THEN Messuja((Atime MOD 10)+51);
    Writeln;
    Character[Kuka,MaxLoad] := 5;
    hamatack:=7;
    jokisortuu:=6;
    IF NOT FirstTime
      THEN
        IF (Input^ IN ['y','Y'])
          THEN messuja(AlkuPaikka+LyhytKuvaus)
            ELSE BEGIN
                   messuja(AlkuPaikka+PitkaKuvaus);
                   IF VisitThePlace[2,Character[Kuka,Now]]<>0
                     THEN Messuja(VisitThePlace[2,Character[Kuka,Now]]);
                 END
        ELSE Writeln('Remember to save this version.');
    Writeln;
  END(* Alkuluvut *);
 
PROCEDURE KaikkiKomennot(VAR Cmd:Integer);
 
  PROCEDURE LueSuunta(VAR Cmd:Integer);
    BEGIN(* LueSuunta *)
      StartTulkki(Cmd);
      IF Minus THEN Move(Loput)
        ELSE IF Return THEN Move(Loput);
    END(* LueSuunta *);
 
  PROCEDURE ToinenSVerbi(VAR Cmd:Integer);
    BEGIN(* ToinenSVerbi *)
      StartTulkki(Cmd);
      IF Minus THEN ActionVerbs(Loput,SaveWord1)
        ELSE IF Return THEN ActionVerbs(Loput,SaveWord1);
    END(* ToinenSVerbi *);
 
  PROCEDURE ToinenSEsine(VAR Cmd:Integer);
    BEGIN(* ToinenSEsine *)
      StartTulkki(Cmd);
      IF NOT Minus THEN Minus := Return;
      IF Minus THEN
       CASE Tuhat OF
        2:IF OnkoPaikalla(Loput)=0 THEN Messuja(105)
          ELSE ActionVerbs(SaveWord1,Loput);
        6:IF (Pedot[Loput,1]<>Character[Kuka,Now]) AND
             (Pedot[Loput,1]<>Character[Kuka,Now]) THEN Messuja(111)
                                                   ELSE Messuja(247);
        8:Messuja(183);
        11:Messuja(667);
       END(* CASE *);
    END(* ToinenSEsine *);
 
  PROCEDURE ToinenSBattle(VAR Cmd:Integer);
    BEGIN(* ToinenSBattle *)
      StartTulkki(Cmd);
      IF Minus THEN FighterVerbs(Loput,SaveWord1)
        ELSE IF Return THEN FighterVerbs(Loput,SaveWord1);
    END(* ToinenSBattle *);
 
  PROCEDURE ToinenSBeast(VAR Cmd:Integer);
    BEGIN(* ToinenSBeast *)
      StartTulkki(Cmd);
      IF NOT Minus THEN Minus:=Return;
      IF Minus THEN
        CASE Tuhat OF
          2:Messuja(247);
          6:IF (Pedot[Loput,1]=Character[Kuka,Now]) OR
               (Pedot[Loput,2]=Character[Kuka,Now]) THEN
                 FighterVerbs(SaveWord1,Loput)
              ELSE Messuja(765);
          8:Messuja(177);
          11:Messuja(668);
        END(* CASE *);
    END(* ToinenSBeast *);
 
  PROCEDURE CPersonality(VAR Cmd:Integer);
    PROCEDURE ChangeIdentity(VAR Cmd:Integer);
      VAR b,s:Integer;
      BEGIN(* ChangeIdentity *)
        StartTulkki(Cmd);
        IF NOT Minus THEN Minus:= Return;
        IF Minus THEN
          BEGIN
            IF Character[Loput-100,Now]<1
              THEN Messuja(669)
              ELSE IF Loput-100=Kuka
                THEN Messuja(662)
                ELSE IF (VisitThePlace[1,
                         Character[Loput-100,Now] MOD MontakoHuonetta]=0)
                        AND (Character[Loput-100,Now]<=MontakoHuonetta)
                  THEN Messuja(670)
                  ELSE (* jo onnistuu *)
                  BEGIN
                    IF NOT AaniViesti THEN
                      BEGIN
                        Messuja(347);
                        AaniViesti:=True;
                      END
                      ELSE BEGIN
                             Write(' Changed to');
                             Messuja(Loput-100+NameKuvaus);
                           END;
                    IF Character[Loput-100,Now]>MontakoHuonetta  (* ei pomona*)
                      THEN BEGIN
                             b:=Character[Loput-100,Now]-MrX; (* pomo *)
                             Character[Loput-100,Now]:=Character[b,Now];
                             Character[b,Now]:=Loput-100+MrX;
                             FOR s:=FirstChrNumber TO HenkiloMaara DO
                               IF Character[s,Now]=b+MrX
                                 THEN Character[s,Now]:=Loput-100+MrX;
                           END;
                    FOR s:=FirstChrNumber TO HenkiloMaara DO
                      IF Character[s,Now]=Kuka+MrX
                        THEN IF (Character[Loput-100,Now]=Character[Kuka,Now])
                          THEN Character[s,Now]:=Loput-100+MrX;
                            (*ELSE Character[s,Now]:=Character[Kuka,Now];*)
                    b:=Kuka; (* vanha kuka *)
                    Kuka:=Loput-100;
                    (* MUTTA jospa henkilll{ onkin sormus sormessa ||| *)
                    IF Character[Kuka,RingOn]<>0 THEN
                      BEGIN
                        NowPlaying:=False;
                        Pelataan:=False;
                        Quitting:=True;
                        Happening:=True;
                        IF (Character[Kuka,Now]>MontakoHuonetta) OR
                           (Character[Kuka,Now]=Character[b,Now])
                          THEN Messuja(5) ELSE Messuja(6);
                      END;
                  END;
          END;
      END(* ChangeIdentity *);
 
    PROCEDURE C2Personality(VAR Cmd:Integer);
      BEGIN(* C2Personality *)
        StartTulkki(Cmd);
        IF Minus THEN BEGIN
                        Cmd:=0;
                        NilLineBuf;
                        prompt:=10;
                        Parser(Names,ChangeIdentity);
                      END
                 ELSE Parser(Names,ChangeIdentity);
      END(* C2Personality *);
    BEGIN(* CPersonality *)
      StartTulkki(Cmd);
      IF Minus THEN BEGIN
                      NilLineBuf;
                      Cmd:=0;
                      prompt:=10;
                      Parser(Names,ChangeIdentity);
                    END
         ELSE Parser(WithCmd,C2Personality);
    END(* CPersonality *);
 
  PROCEDURE Saying(VAR Cmd:Integer);
    PROCEDURE LiityTaiJaa(VAR Cmd:Integer);
      VAR apu,silmu:Integer;
      BEGIN(* LiityTaiJaa *)
        StartTulkki(Cmd);
        apu:=Loput-100;
        IF NOT Minus THEN Minus:=Return;
        IF Minus THEN
          BEGIN
            IF (Character[apu,Now]<>Character[Kuka,Now]) AND
               (Character[apu,Now]<>MrX+Kuka) AND NOT
               ((Character[apu,Now]>MontakoHuonetta) AND
                (Character[(Character[apu,Now]-MrX) MOD (HenkiloMaara+1),Now]=
                 Character[Kuka,Now]))
              THEN BEGIN
                     LfOrNot:=False;
                     Messuja(apu+NameKuvaus);
                     Writeln(' ain''t here.');
                   END
              ELSE IF apu=Kuka THEN Messuja(671)
                ELSE
                  IF Character[Kuka,RingOn]<>0 THEN Messuja(9)
                ELSE
                CASE MitaTuliSanottua OF
                     1:Messuja(672);
                     2:BEGIN
                         Character[apu,Now]:=Kuka+MrX;
                         FOR silmu:=FirstChrNumber TO HenkiloMaara DO
                           IF Character[silmu,Now]=apu+MrX
                             THEN Character[silmu,Now]:=Kuka+MrX;
                         LfOrNot:=False;
                         Messuja(apu+NameKuvaus);
                         Write(':"You are now my Master, ');
                         LfOrNot:=False;
                         Messuja(Kuka+NameKuvaus);
                         Writeln('".');
                       END;
                     3:BEGIN
                         Character[apu,Now]:=Character[Kuka,Now];
                         LfOrNot:=False;
                         Messuja(apu+NameKuvaus);
                         Messuja(673);
                       END;
                   END(* CASE *);
          END;
      END(* LiityTaiJaa *);
 
      PROCEDURE ToToTo(VAR Cmd:Integer);
        BEGIN(* ToToTo *)
          StartTulkki(Cmd);
          IF Minus THEN BEGIN
                          NilLineBuf;
                          Cmd:=0;
                          Prompt:=12;
                        END;
          Parser(Names,LiityTaiJaa);
        END(* ToToTo *);
    BEGIN(* Saying *)
      StartTulkki(Cmd);
      MitaTuliSanottua:=Loput;
      IF Minus THEN BEGIN
                      NilLineBuf;
                      Cmd:=0;
                      Prompt:=12;
                      Parser(Names,LiityTaiJaa);
                    END
        ELSE Parser(ToCmd,ToToTo);
    END(* Saying *);
 
  PROCEDURE TellingSomething(VAR Cmd:Integer);
    PROCEDURE PseudoDoingAtLast(VAR Cmd:Integer);
      VAR s:Integer;
      BEGIN(* PseudoDoingAtLast *)
        StartTulkki(Cmd);
        PseudoObjekti:=Loput;
        IF NOT Minus THEN Minus:=Return;
        IF Minus THEN
          IF NOT ((Character[PseudoHenkilo,Now]=Character[Kuka,Now]) OR
                  (Character[PseudoHenkilo,Now]-MrX=Kuka))
            THEN Messuja(674) ELSE
                 BEGIN
                   LaitettiinMaahan:=False;
                   s:=Kuka;
                   Kuka:=PseudoHenkilo;
                   IF Character[Kuka,Now]>MontakoHuonetta THEN
                     BEGIN
                       Character[Kuka,Now]:=Character[s,Now];
                       LaitettiinMaahan:=True;
                     END;
                   IF Tuhat<>2 THEN Messuja(675)
                     ELSE ActionVerbs(PseudoVerbi,PseudoObjekti);
                   IF LaitettiinMaahan THEN Character[Kuka,Now]:=s+MrX;
                   Kuka:=s;
                 END;
      END(* PseudoDoingAtLast *);
    PROCEDURE PseudoDo(VAR Cmd:Integer);
      BEGIN(* PseudoDo *)
        StartTulkki(Cmd);
        PseudoVerbi:=Loput;
        IF Minus THEN BEGIN
                        prompt:=2;
                        Cmd:=0;
                        NilLineBuf;
                      END;
        Parser(EPACmds,PseudoDoingAtLast);
      END(* PseudoDo *);
    PROCEDURE ToPseudoDo(VAR Cmd:Integer);
      BEGIN(* ToPseudoDo *)
        StartTulkki(Cmd);
        IF Minus THEN BEGIN
                        Cmd:=0;
                        prompt:=2;
                        NilLineBuf;
                      END;
        Parser(Werbit,PseudoDo);
      END(* ToPseudoDo *);
    BEGIN(* TellingSomething *)
      StartTulkki(Cmd);
      PseudoHenkilo:=Loput-100;
      IF Minus THEN BEGIN
                      Cmd:=0;
                      NilLineBuf;
                      prompt:=2;
                      Parser(Werbit,PseudoDo);
                    END
        ELSE Parser(ToCmd,ToPseudoDo);
    END(* TellingSomething *);
 
  BEGIN(* KaikkiKomennot *)
    StartTulkki(Cmd);
    Happening:=False;
    Tarkistus(1);
    IF NOT Happening THEN CASE Tuhat OF
      1:IF Minus THEN (* painettu returnia *)
                   IF Loput<13 THEN Move(Loput) (* liikkuminen *)
                               ELSE BEGIN
                                      NilLineBuf;
                                      Cmd := 0;
                                      prompt:=4;
                                      Parser(Directions,LueSuunta);
                                    END
                 ELSE (* ei returnia *)
                   IF Loput>=13 THEN Parser(Directions,LueSuunta)
                     ELSE IF return THEN Move(Loput);
      2:BEGIN
          IF OnkoPaikalla(Loput)=0 THEN
            BEGIN
              IF NOT Minus THEN Writeln;
              Messuja(105);
            END
            ELSE BEGIN
                   IF NOT Minus THEN Writeln;
                   NilLineBuf;
                   Cmd := 0;
                   SaveWord1:=Loput;
                   prompt:=3;
                   Parser(Werbit,ToinenSVerbi);
                 END;
        END;
      3:BEGIN
          SaveWord1:=Loput;
          IF Minus THEN
            BEGIN
              Cmd := 0;
              NilLineBuf;
              prompt:=2;
            END;
          Parser(EPACmds,ToinenSEsine);
        END;
      4:IF Minus THEN SystemCmd
          ELSE IF Return THEN SystemCmd;
      5:BEGIN
          SaveWord1:=Loput;
          IF Minus THEN
            BEGIN
              Cmd := 0;
              NilLineBuf;
              prompt:=2;
            END;
          Parser(EPACmds,ToinenSBeast);
        END;
      6:BEGIN
          IF (Pedot[Loput,1]<>Character[Kuka,Now]) AND
             (Pedot[Loput,2]<>Character[Kuka,Now]) THEN
            BEGIN
              IF NOT Minus THEN Writeln;
              Messuja(771);
            END
            ELSE BEGIN
                   IF NOT Minus THEN Writeln;
                   NilLineBuf;
                   Cmd := 0;
                   prompt:=3;
                   SaveWord1:=Loput;
                   Parser(BattleW,ToinenSBattle);
                 END;
        END;
      7:Messuja(312);
      8:Messuja(880);
      9:Messuja(897);
      10: (* change identity *)
        IF NOT Minus THEN Parser(Identity,CPersonality)
          ELSE BEGIN
                 NilLineBuf;
                 cmd:=0;
                 prompt:=2;
                 Parser(Identity,CPersonality);
               END;
      11: (* name of a character *)
         BEGIN
           IF NOT Minus THEN Write(' ') (* ei returnia *)
                        ELSE Write('That ');
           IF Loput-100=Kuka THEN Writeln('is your name.')
             ELSE IF (Character[Loput-100,Now]=Character[Kuka,Now]) (* here *)
               THEN Writeln('is here and greets you.')
             ELSE Writeln('isn''t here.');
         END;
      12:BEGIN
           IF Minus THEN BEGIN
                           Cmd:=0;
                           NilLineBuf;
                           prompt:=2;
                         END;
           Parser(SayWhat,Saying);
         END;
      13: (* tell *)
         BEGIN
           IF Minus THEN BEGIN
                           Cmd:=0;
                           NilLineBuf;
                           prompt:=12;
                         END;
           Parser(Names,TellingSomething);
         END;
    end(* case *);
  end(* KaikkiKomennot *);
 
 
PROCEDURE VanderingBeasts;
 
  CONST PedonNimi=6000;
        PedonKuvaus=5200;
        PetoOffset=50;
        PetoE=77;
        YllatysTodennakoisyys=30;
 
  VAR xxx : ^integer;
      Sieto,WhatBeast : Integer;
      Fighting:Boolean;
 
  FUNCTION Armed(VAR x:Integer):Boolean;
    (*VAR silmu:Integer;*)
    BEGIN(* Armed *)
      IF (kamat[99,1]=x+MrX) OR (kamat[30,1]=x+MrX) OR (kamat[10,1]=x+MrX) OR
         (kamat[71,1]=x+MrX)
        THEN Armed:=True ELSE Armed:=False;
    END(* Armed *);
 
 
  PROCEDURE AutoPersonVaihto(Who:Integer);
    VAR silmu,s:Integer;Komps:Boolean;
    BEGIN(* AutoPersonVaihto *)
      Komps:=(OnkoPaikalla(85)=2);
      FOR silmu:=1 TO TavaraMaara DO (* kuolleen kamat maahan *)
        IF Kamat[silmu,1]=Who+MrX THEN Kamat[silmu,1]:=Character[who,Now];
      FOR silmu:=FirstChrNumber TO HenkiloMaara DO
        IF Character[silmu,Now]=Who+MRX (* kaverit maahan *)
          THEN Character[silmu,Now]:=Character[who,Now];
      Character[who,Now]:=0;
      s:=RickRandom(HenkiloMaara-FirstChrNumber)+FirstChrNumber;
      FOR silmu:=s TO HenkiloMaara DO
        IF (Character[silmu,Now]>0) AND (Character[silmu,Now]<=MontakoHuonetta)
          THEN IF (VisitThePlace[1,Character[silmu,Now]]<>0) AND
                  (Kuka=who) AND (silmu<>who) THEN Kuka:=silmu;
      FOR silmu:=FirstChrNumber TO s DO
        IF (Character[silmu,Now]>0) AND (Character[silmu,Now]<=MontakoHuonetta)
          THEN IF (VisitThePlace[1,Character[silmu,Now]]<>0) AND
                  (Kuka=who) AND (silmu<>who) THEN Kuka:=silmu;
      IF Kuka=who THEN
        BEGIN
         Messuja(676);
         NowPlaying:=False;
        END
        ELSE BEGIN
               LfOrNot:=False;
               Messuja(677);
               LfOrNot:=False;
               Messuja(Kuka+NameKuvaus);
               Writeln('.');
               IF Character[Kuka,Now]>MontakoHuonetta THEN
                 Character[Kuka,Now]:=Character[Character[Kuka,Now]-MrX,Now];
               (* MUTTA jospa henkilll{ onkin sormus sormessa ||| *)
               IF Character[Kuka,RingOn]<>0 THEN
                      BEGIN
                        NowPlaying:=False;
                        Pelataan:=False;
                        Quitting:=True;
                        Happening:=True;
                        Messuja(5);
                      END;
             END;
      IF Komps THEN Kamat[85,1]:=MrX+Kuka;
    END(* AutoPersonVaihto *);
 
 
PROCEDURE BeastHit(Lisaa:Integer);
  CONST Kuolema=99;IsoHaava=89;PieniHaava=79;
  VAR Tn:Integer;
  BEGIN(* BeastHit *)
    Tn:=RickRandom(100+Lisaa);
    IF (Tn>Kuolema) AND (Lisaa>0) THEN
      IF Armed(Kuka) THEN Tn:=Kuolema-1
        ELSE (* ei aseistettu ja se oli menoa *)
          BEGIN
            Fighting:=False;
            Pedot[WhatBeast,1]:=0;
            Character[Kuka,NegEndurance]:=0;
            Messuja(678);
            AutoPersonVaihto(Kuka);
          END;
    IF Fighting THEN
      BEGIN
        IF Tn>Kuolema THEN Tn:=1
          ELSE IF Tn>IsoHaava THEN Tn:=2
            ELSE IF Tn>PieniHaava THEN Tn:=3
              ELSE Tn:=4;
        Character[Kuka,NegEndurance]:=Character[Kuka,NegEndurance]-4+Tn;
        IF (Character[Kuka,NegEndurance]<0) OR (Tn=1) THEN
          BEGIN
            LfOrNot:=False;
            Messuja(PedonNimi+WhatBeast);
            Fighting:=False;
            Pedot[WhatBeast,1]:=0;
            Messuja(850+RickRandom(860-850));
            AutoPersonVaihto(Kuka);
          END
          ELSE BEGIN
                 LfOrNot:=False;
                 Messuja(PedonNimi+WhatBeast);
                 CASE Tn OF
                 2:Messuja(830+RickRandom(849-830));
                 3:Messuja(820+RickRandom(829-820));
                 4:Messuja(800+RickRandom(819-800));
                 END(* CASE *);
               END;
      END;
  END(* BeastHit *);
 
 
 
 
 
  PROCEDURE EscapeTheBeast;
    CONST PakoOnnistuu=50;
    BEGIN(* EscapeTheBeast *)
      IF RickRandom(100)>PakoOnnistuu
        THEN
          BEGIN
            Messuja(679);
            BeastHit(-10);
          END
          ELSE BEGIN
                 Pedot[WhatBeast,1]:=0; (* peto siirretaan pois *)
                 Messuja(680);
                 BeastHit(15);
                 Fighting:=False; (* lopetetaan taistelu *)
                 Messuja(681);
               END;
    END(* EscapeTheBeast *);
 
PROCEDURE KillBeast;
  CONST Kuolema=82;IsoHaava=55;PieniHaava=20;
  VAR Tn:Integer;Aseitta:Boolean;
  BEGIN(* KillBeast *)
    Aseitta:=NOT Armed(Kuka);
    Tn:=RickRandom(100);
    IF Aseitta THEN Tn:=Tn-20;
    IF Tn>Kuolema THEN Tn:=1
      ELSE IF Tn>IsoHaava THEN Tn:=2
        ELSE IF Tn>PieniHaava THEN Tn:=3
          ELSE Tn:=4;
    Sieto:=Sieto-4+Tn;
    IF Sieto=0 THEN BEGIN
                      MakeVisible(Muutos[2,WhatBeast].sana,
                                  Muutos[2,WhatBeast].pituus,
                                  EPACmds,False);
                      Fighting:=False;
                      Pedot[WhatBeast,1]:=0;
                      Pedot[WhatBeast,4]:=1;
                      Messuja(682);
                    END
      ELSE
        BEGIN
          CASE Tn OF
            1:BEGIN
                MakeVisible(Muutos[2,WhatBeast].sana,
                            Muutos[2,WhatBeast].pituus,
                            EPACmds,False);
                Fighting:=False;
                Pedot[WhatBeast,1]:=0;
                Pedot[WhatBeast,4]:=1;
                Messuja(683);
              END;
            2:Messuja(684);
            3:Messuja(685);
            4:Messuja(686);
          END(* CASE *);
        END;
    IF Pedot[WhatBeast,1]<>0 THEN BeastHit(0);
  END(* KillBeast *);
 
 
 
 
  PROCEDURE KillVanderingBeast(VAR Cmd:Integer);
    PROCEDURE KillWhatBeast(VAR Cmd:Integer);
      BEGIN(* KillWhatBeast *)
        StartTulkki(Cmd);
        IF NOT Minus THEN Minus:=Return;
        IF Minus THEN
          CASE Tuhat OF
            2:Messuja(234);
            6:BEGIN
                IF (Pedot[Loput,1]=Character[Kuka,Now]) OR
                   (Pedot[Loput,2]=Character[Kuka,Now]) THEN
                 BEGIN
                  IF (Loput<=PetoE) AND (Loput>PetoOffset)
                    THEN KillBeast
                    ELSE Messuja(687);
                 END
                 ELSE Messuja(688);
              END;
            8:Messuja(689);
            11:Messuja(690);
          END(* CASE Tuhat *);
      END(* KillWhatBeast *);
    BEGIN(* KillVanderingBeast *)
      StartTulkki(Cmd);
      IF Loput=8 THEN
        BEGIN
          IF NOT Minus THEN Minus:=Return;
          IF Minus THEN EscapeTheBeast;
        END
      ELSE
        BEGIN
          IF Minus THEN KillBeast
            ELSE Parser(EPACmds,KillWhatBeast);
        END;
    END(* KillVanderingBeast *);
 
 
  BEGIN(* VanderingBeasts *)
    Sieto:=2+RickRandom(3);
    Fighting:=True;
    WhatBeast:=PetoOffset+RickRandom(PetoE-PetoOffset);
    IF Pedot[WhatBeast,4]<>0 (* tapettu jo *)
      THEN BEGIN
             Messuja(691);
             Fighting:=False;
           END
      ELSE
       BEGIN
         MakeVisible(Muutos[2,WhatBeast].sana,
                     Muutos[2,WhatBeast].pituus,
                     EPACmds,True);
        Pedot[WhatBeast,1]:=Character[Kuka,Now];
        Messuja(PedonKuvaus+WhatBeast);
        IF RickRandom(100)<YllatysTodennakoisyys THEN
          BEGIN
            Messuja(692);
            BeastHit(YllatysTodennakoisyys); (* (mika lisa osumatodariin) *)
          END;
        WHILE Fighting DO (* prompt13=Fight> *)
         BEGIN
           Mark(xxx);
           NilLineBuf;
           Cmd:=0;
           prompt:=13;
           IF Fighting THEN Parser(BattleW,KillVanderingBeast);
           Release(xxx);
         END;
       END;
  END(* VanderingBeasts *);
 
 
 
  BEGIN(* OhLord *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*                    P [ [ O H J E L M A                  *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
 
 
    Init_Terminal (1);

    AlkuLuvut; (* suoritetaan muuttujien ym. initialisointi*)
    WHILE pelataan DO
      BEGIN
        IF PlayAgain THEN NewGame;
        WHILE NowPlaying DO
          BEGIN
            Tarkistus(2);
            Mark(x);
            NilLineBuf;
            Cmd := 0;
            prompt:=1;
            IF NowPlaying THEN Parser(AllCmds,KaikkiKomennot);
            Release(x);
          END(* WHILE *);
        Ranking;
        SendMsgToLog('End.',True,Pistemaara);
        IF NOT Quitting THEN Lopetus
          ELSE
            BEGIN
              NowPlaying:=False;
              pelataan:=False;
            END;
      END(* WHILE *);

    Init_Terminal (0);

    IF NOT FirstTime THEN Quit;
  END(* OhLord *).
