(* SysDep.icl -- included by Tools.pas, Events.pas, and Displays.pas *)


(* Include the correct system dependent driver file *)


(******************************************************************************)
(*                                                                            *)
(*  This file is part of BO5, the user interface library for GNU Pascal.      *)
(*                                                                            *)
(*  BO5 will be distributed as free software (probably under the terms of     *)
(*  the GNU Library General Public License) as soon as it will have reached   *)
(*  some state of completion.  Up to that time, you are allowed to use BO5    *)
(*  for non-commercial purposes only.  You may distribute verbatim copies of  *)
(*  BO5 as a whole, but only without -- even a nominal -- fee.  You may not   *)
(*  distribute parts or changed versions of BO5.  I stress that there is      *)
(*  absolutely NO WARRANTY for BO5 -- any risk of using BO5 is with you!      *)
(*                                                                            *)
(*  Copyright (C) 1995  Peter Gerwinski, Duesseldorfer Str. 35                *)
(*                      (with TeX: D\"usseldorfer Str. 35)                    *)
(*                      45145 Essen, Germany                                  *)
(*                      e-mail: pege@mail.theo-phys.uni-essen.de              *)
(*                                                                            *)
(******************************************************************************)


(*$ifdef EMX *)
  (*$I EMX.icl *)
(*$else *) (*$ifdef OS2PM *)
  (*$I OS2pm.icl *)  (* not in distribution 0.01 *)
(*$else *) (*$ifdef WINDOWS *)
  (*$I Windows.icl *)  (* not in distribution 0.01 *)
(*$else *) (*$ifdef LINUX *)
  (*$I Linux.icl *)
(*$else *) (*$ifdef X11 *)
  (*$I X11.icl *)  (* not in distribution 0.01 *)
(*$else *) (*$ifdef TERMCAP *)
  (*$I TermCap.icl *)
(*$else *)
  (* No operation system specified.  Complain. *)
  (*$M
    Please define EMX (for DOS and OS/2), LINUX or TERMCAP to compile BO5:
    gpc -D LINUX test.pas
  *)
(*$endif *) (*$endif *) (*$endif *) (*$endif *) (*$endif *) (*$endif *)
